/*
 * bltMac.h --
 */

#ifndef _BLT_MACOSX_H
#define _BLT_MACOSX_H

#define XFlush(data)
#define XFree(data) {if ((data) != NULL) ckfree((char *) (data));}
#define XVisualIDFromVisual(visual) (visual->visualid);

extern void XCopyArea(Display *display, Drawable src, Drawable dest,
		      GC gc, int src_x, int src_y, unsigned int width, 
		      unsigned int height, int dest_x, int dest_y);
extern void XCopyPlane(Display *display, Drawable src,
		       Drawable dest, GC gc, int src_x, int src_y, 
		       unsigned int width, unsigned int height, 
		       int dest_x, int dest_y, unsigned long plane);
extern void XDrawArc(Display* display, Drawable d, GC gc, int x, int y,
		     unsigned int width, unsigned int height,
		     int angle1, int angle2);
extern void XDrawLine(Display* display, Drawable d, GC gc,
		      int x1, int y1, int x2, int y2);
extern void XDrawLines(Display *display, Drawable drawable, GC gc,
		       XPoint *pointArr, int nPoints, int mode);
extern void XDrawRectangle(Display *display, Drawable drawable,
			   GC gc, int x, int y, unsigned int width, 
			   unsigned int height);
extern void XDrawSegments(Display *display, Drawable drawable,
			  GC gc, XSegment *segArr, int nSegments);
extern void XFillArc(Display* display, Drawable d, GC gc, int x, int y,
		     unsigned int width, unsigned int height,
		     int angle1, int angle2);
extern void XFillRectangle(Display *display, Drawable drawable,
			   GC gc, int x, int y, unsigned int width, 
			   unsigned int height);
extern void XFillRectangles(Display *display, Drawable drawable,
			    GC gc, XRectangle *rectArr, int nRects);
extern void XFillPolygon(Display *display, Drawable drawable,
			 GC gc, XPoint *points, int nPoints,  
			 int shape, int mode);
extern void XMapWindow(Display *display, Window window);
extern void XSetDashes(Display *display, GC gc, int dashOffset,
		       _Xconst char *dashList, int n);
extern int XSync (Display *display, Bool flag);
extern void XUnmapWindow(Display *display, Window window);

#define XAllocColorCells        Blt_XAllocColorCells
#define XCreateWindow           Blt_XCreateWindow
#define XDeleteProperty         Blt_XDeleteProperty
#define XDrawArcs		Blt_XDrawArcs
#define XDrawPoints		Blt_XDrawPoints
#define XDrawRectangles		Blt_XDrawRectangles
#define XDrawString             Blt_XDrawString
#define XGetCommand             Blt_XGetCommand
#define XFetchBuffer            Blt_XFetchBuffer
#define XFetchName              Blt_XFetchName
#define XFillArcs		Blt_XFillArcs
#define XFreeFont               Blt_XFreeFont
#define XFreePixmap             Blt_XFreePixmap
#define XFreeStringList         Blt_XFreeStringList
#define XGetWindowAttributes	Blt_XGetWindowAttributes
#define XGetFontProperty        Blt_XGetFontProperty
#define XLoadQueryFont          Blt_XLoadQueryFont
#define XLowerWindow		Blt_XLowerWindow
#define XMaxRequestSize         Blt_XMaxRequestSize
#define XPutImage               Blt_XPutImage
#define XRaiseWindow		Blt_XRaiseWindow
#define XReparentWindow		Blt_XReparentWindow
#define XRotateBuffers          Blt_XRotateBuffers
#define XStoreBuffer            Blt_XStoreBuffer
#define XTranslateCoordinates   Blt_XTranslateCoordinates
#define XWarpPointer		Blt_XWarpPointer

extern Status Blt_XAllocColorCells(Display *display, Colormap colormap, 
				   Bool contig, 
				   unsigned long plane_masks_return, 
				   unsigned int nplanes, 
				   unsigned long pixels_return, 
				   unsigned int npixels);
extern Window Blt_XCreateWindow(Display *display, Window parent, 
				int x, int y,
				unsigned int width, unsigned int height,
				unsigned int border_width, int depth,
				unsigned int class, Visual *visual,
				unsigned long valuemask,
				XSetWindowAttributes *attributes);

extern void Blt_XDeleteProperty(Display *display, Window w, Atom property);
extern void Blt_XDrawArcs(Display *display, Drawable drawable, GC gc,
			  XArc *arcArr, int nArcs);
extern void Blt_XDrawPoints(Display *display, Drawable drawable, GC gc,
			    XPoint *pointArr, int nPoints, int mode);
extern void Blt_XDrawRectangles(Display *display, Drawable drawable,
				GC gc, XRectangle *rectArr, int nRects);
extern void Blt_XDrawString(Display* display, Drawable drawable, GC gc, 
			    int x, int y, _Xconst char* str, int length);
extern Status Blt_XGetCommand(Display *display, Window w, char ***argv_return, 
			      int *argc_return);
extern Bool Blt_XGetFontProperty(XFontStruct *font_struct, Atom atom,
				 unsigned long *value_return);
extern Status Blt_XFetchName(Display *display, Window w, 
			     char **window_name_return);
extern char *Blt_XFetchBuffer(Display *display, int *nbytes_return, int buffer);
extern void Blt_XFillArcs(Display *display, Drawable drawable, GC gc,
			  XArc *arcArr, int nArcs);
extern void Blt_XFlush(Display *display);
extern void Blt_XFree(void *ptr);
extern void Blt_XFreeFont(Display *display,  XFontStruct *font_struct);
extern void Blt_XFreePixmap(Display *display, Pixmap pixmap);
extern void Blt_XFreeStringList(char **list);
extern int Blt_XGetWindowAttributes(Display *display, Window window,
				    XWindowAttributes * attrsPtr);
extern XFontStruct *Blt_XLoadQueryFont(Display *display, char *name);
extern void Blt_XLowerWindow(Display *display, Window window);
extern long Blt_XMaxRequestSize(Display *display);
extern void Blt_XPutImage(Display *display, Drawable d, GC gc,XImage *image,
			  int src_x, int src_y, int dest_x, int dest_y,
			  unsigned int width, unsigned int height);
extern void Blt_XRaiseWindow(Display *display, Window window);
extern void Blt_XReparentWindow(Display *display, Window window,
				Window parent, int x, int y);
extern void Blt_XRotateBuffers(Display *display, int rotate);
extern void Blt_XStoreBuffer(Display *display, char *bytes, 
			     int nbytes, int buffer);
extern Bool Blt_XTranslateCoordinates(Display *display, Window src_w, 
				      Window dest_w, int src_x, int src_y,
				      int *dest_x_return, int *dest_y_return,
				      Window *child_return);
extern void Blt_XWarpPointer(Display *display, Window srcWindow,
			     Window destWindow, int srcX, int srcY, 
			     unsigned int srcWidth,
			     unsigned int srcHeight, int destX, int destY);

#endif /*_BLT_MAC_H*/
