// Copyright (C) 1999-2006
// Smithsonian Astrophysical Observatory, Cambridge, MA, USA
// For conditions of distribution and use, see copyright notice in "copyright"

#include <iostream>
#include <sstream>
#include <iomanip>
using namespace std;

#include <tcl.h>
#include <Xlib.h>

// we need these routines because Tk's versions are too simplistic

void XXGetImage(Display *display, Drawable d, int x, int y,
		unsigned int width, unsigned int height,
		unsigned long plane_mask, int format)
{ 
  XImage *   imagePtr = NULL;
  Pixmap     pixmap = (Pixmap) NULL;
  Tk_Window  win = (Tk_Window) ((MacDrawable *) d)->winPtr;
  GC         gc;
  int        depth = 32;
  int        offset = 0;
  int        bitmap_pad = 32;
  int        bytes_per_line = 0;
    
  if (TkMacOSXGetDrawablePort(d)) {
    if (format == ZPixmap) {
      if (width > 0 && height > 0) {
	/* Tk_GetPixmap fails for zero width or height */
	pixmap = Tk_GetPixmap(display, d, width, height, depth);
      }
      if (win) {
	XGCValues values;
	gc = Tk_GetGC(win, 0, &values);
      } else {
	gc = XCreateGC(display, pixmap, 0, NULL);
      }
      if (pixmap) {
	XCopyArea(display, d, pixmap, gc, x, y, width, height, 0, 0);
      }
      imagePtr = XCreateImage(display, NULL, depth, format, offset,
			      (char*)TkMacOSXGetDrawablePort(pixmap), 
			      width, height, bitmap_pad, bytes_per_line);
      /* Track Pixmap underlying the XImage in the unused obdata field *
       * so that we can treat XImages coming from XGetImage specially. */
      imagePtr->obdata = (XPointer) pixmap;
      if (!win) {
	XFreeGC(display, gc);
      }
    } else {
      TkpDisplayWarning(
			"XGetImage: only ZPixmap types are implemented",
			"XGetImage Failure");
    }
  }
  return imagePtr;
}

void XXWarpPointer(Display* display, Window src_w, Window dest_w,
		   int src_x, int src_y,
		   unsigned int src_width, unsigned int src_height,
		   int dest_x, int dest_y)
{
}

