// Copyright (C) 1999-2006
// Smithsonian Astrophysical Observatory, Cambridge, MA, USA
// For conditions of distribution and use, see copyright notice in "copyright"

#ifndef __xxlib_h__
#define __xxlib_h__

#include <tcl.h>
#include <tk.h>
#include <Xlib.h>

// direct X11 to Tk

inline void XDrawString(Display* display, Drawable drawable, GC gc, 
			int x, int y, _Xconst char* str, int length)
{Tk_DrawChars(display, drawable, gc, NULL, str, length, x, y);}

inline void XFreePixmap(Display* display, Pixmap pixmap)
{Tk_FreePixmap(display, pixmap);}

inline Pixmap XCreatePixmap(Display* display, Drawable drawable, 
			    unsigned int width, unsigned int height,
			    unsigned int depth)
{Tk_GetPixmap(display, drawable, width, height, depth);}

inline void XPutImage(Display* display, Drawable d, GC gc, XImage* image,
		      int src_x, int src_y, int dest_x, int dest_y,
		      unsigned int width, unsigned int height)
{TkPutImage(NULL, 0, display, d, gc, image, src_x, src_y, dest_x, dest_y, width, height);}

// Redefined Routines

void XXWarpPointer(Display* display, Window src_w, Window dest_w,
		   int src_x, int src_y,
		   unsigned int src_width, unsigned int src_height,
		   int dest_x, int dest_y);

// Not Supported

inline void XSetClipRectangles(Display* display, GC gc, int clip_x_origin,
			       int  clip_y_origin, XRectangle* r,
			       int  n, int  ordering) {}

inline void XInstallColormap(Display* display, Colormap colormap) {}

inline Status XAllocColorCells(Display* display, Colormap xcmap, Bool contig,
			       unsigned long *planes_mask, unsigned int nplanes,
			       unsigned long *pixels, unsigned int ncolors) {}

inline void XStoreColors(Display* display, Colormap xcmap, XColor* color,
			 int ncolors) {}

#endif
