// Copyright (C) 1999-2006
// Smithsonian Astrophysical Observatory, Cambridge, MA, USA
// For conditions of distribution and use, see copyright notice in "copyright"

#ifndef __framepseudocolor_h__
#define __framepseudocolor_h__

#include "frame.h"
#include "framepseudo.h"

class FramePseudoColor : public Frame, public FramePseudo {
private:
  void fillXImageSingle(XImage*, int, int, int, int, double* (FitsImage::*)());
  void fillXImageMosaic(XImage*, int, int, int, int, double* (FitsImage::*)());
  void fillXImageMosaicFast(XImage*, int, int, int, int, 
			    double* (FitsImage::*)());

  void psLevel2(PSColorSpace, int, int, float);
  void psLevel2Single(PSColorSpace, int, int, float);
  void psLevel2Mosaic(PSColorSpace, int, int, float);
  void psLevel2MosaicFast(PSColorSpace, int, int, float);

public:
  FramePseudoColor(Tcl_Interp*, Tk_Canvas, Tk_Item*);
  ~FramePseudoColor();

  void colormapCmd(int, float, float, int, unsigned short*, 
		   unsigned char*, int);
  void colormapMotionCmd(int id, float b, float c, int i, unsigned short*,
			 unsigned char* ptr, int cnt) {}
  void colormapEndCmd(int id, float b, float c, int i, unsigned short* index, 
		      unsigned char* cells, int cnt)
    {colormapCmd(id,b,c,i,index,cells,cnt);}
};

#endif
