#  Copyright (C) 1999-2005
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc CreateButtons {} {
    global ds9
    global menu
    global buttons

    set buttons(file) $menu(file)
    set buttons(edit) $menu(edit)
    set buttons(view) $menu(view)
    set buttons(frame) $menu(frame)
    set buttons(bin) $menu(bin)
    set buttons(zoom) $menu(zoom)
    set buttons(scale) $menu(scale)
    set buttons(color) $menu(color)
    set buttons(region) $menu(region)
    set buttons(wcs) $menu(wcs)
    set buttons(help) $menu(help)
    set buttons(more) [msgcat::mc "more..."]

    # common buttons
    set buttons(wcs,image) [msgcat::mc "image"]
    set buttons(wcs,physical) [msgcat::mc "physical"]
    set buttons(wcs,amplifier) [msgcat::mc "amplifier"]
    set buttons(wcs,detector) [msgcat::mc "detector"]
    set buttons(wcs,wcs) [msgcat::mc "wcs"]
    set buttons(wcs,fk4) [msgcat::mc "fk4"]
    set buttons(wcs,fk5) [msgcat::mc "fk5"]
    set buttons(wcs,icrs) [msgcat::mc "icrs"]
    set buttons(wcs,galactic) [msgcat::mc "galactic"]
    set buttons(wcs,ecliptic) [msgcat::mc "ecliptic"]
    set buttons(wcs,degrees) [msgcat::mc "degrees"]
    set buttons(wcs,sexagesimal) [msgcat::mc "sexagesimal"]

    set ds9(buttons) [frame $ds9(main).buttons]

    frame $ds9(buttons).major
    pack $ds9(buttons).major -side top -fill x -expand true

    RadioButton $ds9(buttons).major.file $buttons(file) \
	buttons(majorCurrent) $ds9(buttons).file MajorButton
    RadioButton $ds9(buttons).major.edit $buttons(edit) \
	buttons(majorCurrent) $ds9(buttons).edit MajorButton
    RadioButton $ds9(buttons).major.view $buttons(view) \
	buttons(majorCurrent) $ds9(buttons).view MajorButton
    RadioButton $ds9(buttons).major.frame $buttons(frame) \
	buttons(majorCurrent) $ds9(buttons).frame MajorButton
    RadioButton $ds9(buttons).major.bin $buttons(bin) \
	buttons(majorCurrent) $ds9(buttons).bin MajorButton
    RadioButton $ds9(buttons).major.zoom $buttons(zoom) \
	buttons(majorCurrent) $ds9(buttons).zoom MajorButton
    RadioButton $ds9(buttons).major.scale $buttons(scale) \
	buttons(majorCurrent) $ds9(buttons).scale MajorButton
    RadioButton $ds9(buttons).major.color1 $buttons(color) \
	buttons(majorCurrent) $ds9(buttons).color1 MajorButton
    RadioButton $ds9(buttons).major.region $buttons(region) \
	buttons(majorCurrent) $ds9(buttons).region1 MajorButton
    RadioButton $ds9(buttons).major.wcs1 $buttons(wcs) \
	buttons(majorCurrent) $ds9(buttons).wcs1 MajorButton
    RadioButton $ds9(buttons).major.help $buttons(help) \
	buttons(majorCurrent) $ds9(buttons).help MajorButton

    FileButtons
    EditButtons
    ViewButtons
    FrameButtons
    BinButtons
    ZoomButtons
    ScaleButtons
    ColorButtons
    RegionButtons
    WCSButtons
    HelpButtons

    set buttons(majorPrev) ""
    set buttons(majorCurrent) $ds9(buttons).file
    MajorButton
}

proc ButtonButton {button text cmd} {
    button $button \
	-text $text \
	-command $cmd \
	-takefocus 0 \
	-bd 1 \
	-height 1 \
	-padx 2 -pady 2

    pack $button -side left -fill x -expand true
}

proc RadioButton {button text var value cmd} {
    radiobutton $button \
	-text $text \
	-variable $var \
	-value $value \
	-command $cmd \
	-indicatoron false \
	-selectcolor "" \
	-takefocus 0 \
	-bd 1 \
	-height 1 \
	-padx 2 -pady 3

    pack $button -side left -fill x -expand true
}

proc CheckButton {button text var cmd} {
    checkbutton $button \
	-text $text \
	-variable $var \
	-command $cmd \
	-indicatoron false \
	-selectcolor "" \
	-takefocus 0 \
	-bd 1 \
	-height 1 \
	-padx 2 -pady 3

    pack $button -side left -fill x -expand true
}

proc MajorButton {} {
    global buttons

    pack forget $buttons(majorPrev)
    pack $buttons(majorCurrent) -side top -fill x -expand true
    set buttons(majorPrev) $buttons(majorCurrent)
}



