#  Copyright (C) 1999-2005
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc FrameMenu {} {
    global ds9
    global menu

    # Frame Menu
    # WARNING: this is a variable length menu. Be sure to update frame.tcl

    set menu(frame,new) [msgcat::mc "New Frame"]
    set menu(frame,newrgb) [msgcat::mc "New Frame RGB"]
    set menu(frame,delete) [msgcat::mc "Delete Frame"]
    set menu(frame,deleteall) [msgcat::mc "Delete All Frames"]
    set menu(frame,clear) [msgcat::mc "Clear Frame"]
    set menu(frame,reset) [msgcat::mc "Reset Frame"]
    set menu(frame,refresh) [msgcat::mc "Refresh Frame"]
    set menu(frame,single) [msgcat::mc "Single Frame"]
    set menu(frame,tile) [msgcat::mc "Tile Frames"]
    set menu(frame,blink) [msgcat::mc "Blink Frames"]
    set menu(frame,tile,param) [msgcat::mc "Tile"]
    set menu(frame,blink,param) [msgcat::mc "Blink Interval"]
    set menu(frame,display) [msgcat::mc "Set Display Size"]
    set menu(frame,match,frames) [msgcat::mc "Match Frames"]
    set menu(frame,match,colorbars) [msgcat::mc "Match Colorbars"]
    set menu(frame,match,scales) [msgcat::mc "Match Scales"]
    set menu(frame,lock,crosshairs) [msgcat::mc "Lock Crosshairs"]
    set menu(frame,datacube) [msgcat::mc "Data Cube..."]
    set menu(frame,rgb) [msgcat::mc "RGB..."]
    set menu(frame,active) [msgcat::mc "Show/Hide Frames"]

    menu $ds9(mb).frame -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Frame"
    $ds9(mb).frame add command -label $menu(frame,new) -command CreateFrame
    $ds9(mb).frame add command -label $menu(frame,newrgb) \
	-command CreateRGBFrame
    $ds9(mb).frame add separator
    $ds9(mb).frame add command -label $menu(frame,delete) \
	-command DeleteFrameMenu
    $ds9(mb).frame add command -label $menu(frame,deleteall) \
	-command DeleteAllFramesMenu
    $ds9(mb).frame add separator
    $ds9(mb).frame add command -label $menu(frame,clear) \
	-command ClearCurrentFrame
    $ds9(mb).frame add command -label $menu(frame,reset) \
	-command ResetCurrentFrame
    $ds9(mb).frame add command -label $menu(frame,refresh) \
	-command UpdateCurrentFrame
    $ds9(mb).frame add separator
    $ds9(mb).frame add radiobutton -label $menu(frame,single) \
	-variable ds9(display,user) -value single -command DisplayMode
    $ds9(mb).frame add radiobutton -label $menu(frame,tile) \
	-variable ds9(display,user) -value tile -command DisplayMode
    $ds9(mb).frame add radiobutton -label $menu(frame,blink) \
	-variable ds9(display,user) -value blink -command DisplayMode
    $ds9(mb).frame add separator
    $ds9(mb).frame add cascade -label $menu(frame,tile,param) \
	-menu $ds9(mb).frame.tile
    $ds9(mb).frame add cascade -label $menu(frame,blink,param) \
	-menu $ds9(mb).frame.blink
    $ds9(mb).frame add command -label $menu(frame,display) \
	-command DisplayDefaultDialog
    $ds9(mb).frame add separator
    $ds9(mb).frame add cascade -label $menu(frame,match,frames) \
	-menu $ds9(mb).frame.match
    $ds9(mb).frame add command -label $menu(frame,match,colorbars) \
	-command MatchColorbars
    $ds9(mb).frame add command -label $menu(frame,match,scales) \
	-command MatchScales
    $ds9(mb).frame add separator
    $ds9(mb).frame add cascade -label $menu(frame,lock,crosshairs) \
	-menu $ds9(mb).frame.crosshair
    $ds9(mb).frame add separator
    $ds9(mb).frame add command -label $menu(frame,datacube) \
	-command CubeDialog
    $ds9(mb).frame add command -label $menu(frame,rgb) \
	-command RGBDialog
    $ds9(mb).frame add separator
    $ds9(mb).frame add cascade -label $menu(frame,active) \
	-menu $ds9(mb).frame.active
    $ds9(mb).frame add separator

    set menu(frame,active,show) [msgcat::mc "Show All"]
    set menu(frame,active,hide) [msgcat::mc "Hide All"]

    menu $ds9(mb).frame.active -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Frame Show/Hide"
    $ds9(mb).frame.active add command -label $menu(frame,active,show) \
	-command ActiveFrameAll
    $ds9(mb).frame.active add command -label $menu(frame,active,hide) \
	-command ActiveFrameNone
    $ds9(mb).frame.active add separator

    menu $ds9(mb).frame.match -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Frame Match"
    $ds9(mb).frame.match add command -label $menu(wcs) \
	-command MatchFramesWCS
    $ds9(mb).frame.match add command -label $menu(wcs,image) \
	-command {MatchFrames image}
    $ds9(mb).frame.match add command -label $menu(wcs,physical) \
	-command {MatchFrames physical}
    $ds9(mb).frame.match add command -label $menu(wcs,amplifier) \
	-command {MatchFrames amplifier}
    $ds9(mb).frame.match add command -label $menu(wcs,detector) \
	-command {MatchFrames detector}

    set menu(frame,crosshair,none) [msgcat::mc "None"]

    menu $ds9(mb).frame.crosshair -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Frame Crosshair"
    $ds9(mb).frame.crosshair add radiobutton \
	-label $menu(frame,crosshair,none) \
	-variable crosshair(lock) -value none
    $ds9(mb).frame.crosshair add separator
    $ds9(mb).frame.crosshair add radiobutton -label $menu(wcs) \
	-variable crosshair(lock) -value wcs
    $ds9(mb).frame.crosshair add cascade -label $menu(wcs,multi) \
	-menu $ds9(mb).frame.crosshair.wcs
    $ds9(mb).frame.crosshair add separator
    $ds9(mb).frame.crosshair add radiobutton -label $menu(wcs,image) \
	-variable crosshair(lock) -value image
    $ds9(mb).frame.crosshair add radiobutton -label $menu(wcs,physical) \
	-variable crosshair(lock) -value physical
    $ds9(mb).frame.crosshair add radiobutton -label $menu(wcs,amplifier) \
	-variable crosshair(lock) -value amplifier
    $ds9(mb).frame.crosshair add radiobutton -label $menu(wcs,detector) \
	-variable crosshair(lock) -value detector

    menu $ds9(mb).frame.crosshair.wcs -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	$ds9(mb).frame.crosshair.wcs add radiobutton \
	    -label "$menu(wcs) $l" \
	    -variable crosshair(lock) -value "wcs$l"
    }

    set menu(frame,tile,grid) [msgcat::mc "Grid"]
    set menu(frame,tile,column) [msgcat::mc "Columns"]
    set menu(frame,tile,row) [msgcat::mc "Rows"]
    set menu(frame,tile,params) [msgcat::mc "Grid Parameters..."]

    menu $ds9(mb).frame.tile -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).frame.tile add radiobutton -label $menu(frame,tile,grid) \
	-variable tile(mode) -value grid -command DisplayMode
    $ds9(mb).frame.tile add radiobutton -label $menu(frame,tile,column) \
	-variable tile(mode) -value column -command DisplayMode
    $ds9(mb).frame.tile add radiobutton -label $menu(frame,tile,row) \
	-variable tile(mode) -value row -command DisplayMode
    $ds9(mb).frame.tile add separator
    $ds9(mb).frame.tile add command -label $menu(frame,tile,params) \
	-command TileDialog

    set menu(frame,blink,.125) [msgcat::mc ".125 Seconds"]
    set menu(frame,blink,.25) [msgcat::mc ".25 Seconds"]
    set menu(frame,blink,.5) [msgcat::mc ".5 Seconds"]
    set menu(frame,blink,1) [msgcat::mc "1 Second"]
    set menu(frame,blink,2) [msgcat::mc "2 Seconds"]
    set menu(frame,blink,4) [msgcat::mc "4 Seconds"]
    set menu(frame,blink,8) [msgcat::mc "8 Seconds"]

    menu $ds9(mb).frame.blink -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).frame.blink add radiobutton -label $menu(frame,blink,.125) \
	-variable blink(interval) -value 125
    $ds9(mb).frame.blink add radiobutton -label $menu(frame,blink,.25) \
	-variable blink(interval) -value 250
    $ds9(mb).frame.blink add radiobutton -label $menu(frame,blink,.5) \
	-variable blink(interval) -value 500
    $ds9(mb).frame.blink add radiobutton -label $menu(frame,blink,1) \
	-variable blink(interval) -value 1000
    $ds9(mb).frame.blink add radiobutton -label $menu(frame,blink,2) \
	-variable blink(interval) -value 2000
    $ds9(mb).frame.blink add radiobutton -label $menu(frame,blink,4) \
	-variable blink(interval) -value 4000
    $ds9(mb).frame.blink add radiobutton -label $menu(frame,blink,8) \
	-variable blink(interval) -value 8000

    FramePrefsMenu
}

proc FramePrefsMenu {} {
    global ds9
    global menu
    global prefs

    menu $ds9(mb).prefs.gui.frame -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.gui.frame add cascade -label $menu(frame,tile,param) \
	-menu $ds9(mb).prefs.gui.frame.tile
    $ds9(mb).prefs.gui.frame add cascade -label $menu(frame,blink,param) \
	-menu $ds9(mb).prefs.gui.frame.blink

    menu $ds9(mb).prefs.gui.frame.tile -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.gui.frame.tile add radiobutton \
	-label $menu(frame,tile,grid) \
	-variable prefs(tile,mode) -value grid -command SavePrefs
    $ds9(mb).prefs.gui.frame.tile add radiobutton \
	-label $menu(frame,tile,column) \
	-variable prefs(tile,mode) -value column -command SavePrefs
    $ds9(mb).prefs.gui.frame.tile add radiobutton \
	-label $menu(frame,tile,row) \
	-variable prefs(tile,mode) -value row -command SavePrefs

    menu $ds9(mb).prefs.gui.frame.blink -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.gui.frame.blink add radiobutton \
	-label $menu(frame,blink,.125) \
	-variable prefs(blink,interval) -value 125 -command SavePrefs
    $ds9(mb).prefs.gui.frame.blink add radiobutton \
	-label $menu(frame,blink,.25) \
	-variable prefs(blink,interval) -value 250 -command SavePrefs
    $ds9(mb).prefs.gui.frame.blink add radiobutton \
	-label $menu(frame,blink,.5) \
	-variable prefs(blink,interval) -value 500 -command SavePrefs
    $ds9(mb).prefs.gui.frame.blink add radiobutton \
	-label $menu(frame,blink,1) \
	-variable prefs(blink,interval) -value 1000 -command SavePrefs
    $ds9(mb).prefs.gui.frame.blink add radiobutton \
	-label $menu(frame,blink,2) \
	-variable prefs(blink,interval) -value 2000 -command SavePrefs
    $ds9(mb).prefs.gui.frame.blink add radiobutton \
	-label $menu(frame,blink,4) \
	-variable prefs(blink,interval) -value 4000 -command SavePrefs
    $ds9(mb).prefs.gui.frame.blink add radiobutton \
	-label $menu(frame,blink,8) \
	-variable prefs(blink,interval) -value 8000 -command SavePrefs
}

proc FrameButtons {} {
    global ds9
    global buttons

    set buttons(frame,new) [msgcat::mc "new"]
    set buttons(frame,newrgb) [msgcat::mc "new rgb"]
    set buttons(frame,delete) [msgcat::mc "delete"]
    set buttons(frame,deleteall) [msgcat::mc "delete all"]
    set buttons(frame,clear) [msgcat::mc "clear"]
    set buttons(frame,reset) [msgcat::mc "reset"]
    set buttons(frame,single) [msgcat::mc "single"]
    set buttons(frame,tile) [msgcat::mc "tile"]
    set buttons(frame,blink) [msgcat::mc "blink"]
    set buttons(frame,first) [msgcat::mc "first"]
    set buttons(frame,prev) [msgcat::mc "previous"]
    set buttons(frame,next) [msgcat::mc "next"]
    set buttons(frame,last) [msgcat::mc "last"]

    frame $ds9(buttons).frame
    ButtonButton $ds9(buttons).frame.new $buttons(frame,new) CreateFrame
    ButtonButton $ds9(buttons).frame.newrgb $buttons(frame,newrgb) \
	CreateRGBFrame
    ButtonButton $ds9(buttons).frame.delete $buttons(frame,delete) \
	DeleteFrameMenu
    ButtonButton $ds9(buttons).frame.deleteall $buttons(frame,deleteall) \
	DeleteAllFramesMenu
    ButtonButton $ds9(buttons).frame.clear $buttons(frame,clear) \
	ClearCurrentFrame
    ButtonButton $ds9(buttons).frame.reset $buttons(frame,reset) \
	ResetCurrentFrame
    RadioButton $ds9(buttons).frame.single $buttons(frame,single) \
	ds9(display,user) single DisplayMode
    RadioButton $ds9(buttons).frame.tile $buttons(frame,tile) \
	ds9(display,user) tile DisplayMode
    RadioButton $ds9(buttons).frame.blink $buttons(frame,blink) \
	ds9(display,user) blink DisplayMode
    ButtonButton $ds9(buttons).frame.first $buttons(frame,first) FirstFrame
    ButtonButton $ds9(buttons).frame.prev $buttons(frame,prev) PrevFrame
    ButtonButton $ds9(buttons).frame.next $buttons(frame,next) NextFrame
    ButtonButton $ds9(buttons).frame.last $buttons(frame,last) LastFrame
}

proc UpdateFrameMenu {} {
    global ds9
    global current
    global menu
    global rgb

    global debug
    if {$debug(tcl,update)} {
	puts "UpdateFrameMenu"
    }

    switch -- $ds9(visual) {
	pseudocolor {
	    $ds9(mb).frame entryconfig $menu(frame,newrgb) -state disabled
	    $ds9(buttons).frame.newrgb configure -state disabled
	}
	truecolor {
	    $ds9(mb).frame entryconfig $menu(frame,newrgb) -state normal
	    $ds9(buttons).frame.newrgb configure -state normal
	}
    }

    if {$current(frame) != {}} {
	$ds9(mb).frame entryconfig $menu(frame,delete) -state normal
	$ds9(mb).frame entryconfig $menu(frame,deleteall) -state normal
	$ds9(mb).frame entryconfig $menu(frame,clear) -state normal
	$ds9(mb).frame entryconfig $menu(frame,reset) -state normal
	$ds9(mb).frame entryconfig $menu(frame,refresh) -state normal
	$ds9(mb).frame entryconfig $menu(frame,single) -state normal
	$ds9(mb).frame entryconfig $menu(frame,tile) -state normal
	$ds9(mb).frame entryconfig $menu(frame,blink) -state normal
	$ds9(mb).frame entryconfig $menu(frame,tile,param) -state normal
	$ds9(mb).frame entryconfig $menu(frame,blink,param) -state normal
	$ds9(mb).frame entryconfig $menu(frame,display) -state normal
	$ds9(mb).frame entryconfig $menu(frame,match,frames) -state normal
	$ds9(mb).frame entryconfig $menu(frame,match,colorbars) -state normal
	$ds9(mb).frame entryconfig $menu(frame,lock,crosshairs) -state normal
	$ds9(mb).frame entryconfig $menu(frame,datacube) -state normal

	if {[$current(frame) get type] == "rgb"} {
	    $ds9(mb).frame entryconfig $menu(frame,rgb) -state normal
	} else {
	    $ds9(mb).frame entryconfig $menu(frame,rgb) -state disabled
	}

	$ds9(buttons).frame.delete configure -state normal
	$ds9(buttons).frame.deleteall configure -state normal
	$ds9(buttons).frame.clear configure -state normal
	$ds9(buttons).frame.reset configure -state normal
	$ds9(buttons).frame.single configure -state normal
	$ds9(buttons).frame.tile configure -state normal
	$ds9(buttons).frame.blink configure -state normal
	$ds9(buttons).frame.first configure -state normal
	$ds9(buttons).frame.prev configure -state normal
	$ds9(buttons).frame.next configure -state normal
	$ds9(buttons).frame.last configure -state normal

    } else {
	$ds9(mb).frame entryconfig $menu(frame,delete) -state disabled
	$ds9(mb).frame entryconfig $menu(frame,deleteall) -state disabled
	$ds9(mb).frame entryconfig $menu(frame,clear) -state disabled
	$ds9(mb).frame entryconfig $menu(frame,reset) -state disabled
	$ds9(mb).frame entryconfig $menu(frame,refresh) -state disabled
	$ds9(mb).frame entryconfig $menu(frame,single) -state disabled
	$ds9(mb).frame entryconfig $menu(frame,tile) -state disabled
	$ds9(mb).frame entryconfig $menu(frame,blink) -state disabled
	$ds9(mb).frame entryconfig $menu(frame,tile,param) -state disabled
	$ds9(mb).frame entryconfig $menu(frame,blink,param) -state disabled
	$ds9(mb).frame entryconfig $menu(frame,display) -state disabled
	$ds9(mb).frame entryconfig $menu(frame,match,frames) -state disabled
	$ds9(mb).frame entryconfig $menu(frame,match,colorbars) -state disabled
	$ds9(mb).frame entryconfig $menu(frame,lock,crosshairs) -state disabled
	$ds9(mb).frame entryconfig $menu(frame,datacube) -state disabled
	$ds9(mb).frame entryconfig $menu(frame,rgb) -state disabled

	$ds9(buttons).frame.delete configure -state disabled
	$ds9(buttons).frame.deleteall configure -state disabled
	$ds9(buttons).frame.clear configure -state disabled
	$ds9(buttons).frame.reset configure -state disabled
	$ds9(buttons).frame.single configure -state disabled
	$ds9(buttons).frame.tile configure -state disabled
	$ds9(buttons).frame.blink configure -state disabled
	$ds9(buttons).frame.first configure -state disabled
	$ds9(buttons).frame.prev configure -state disabled
	$ds9(buttons).frame.next configure -state disabled
	$ds9(buttons).frame.last configure -state disabled
    }
}

# Frame Menu Delete
proc UpdateFrameMenuItems {} {
    global ds9

    if {[$ds9(mb).frame index end]>29} {
	$ds9(mb).frame delete 30 end
    }
    if {[$ds9(mb).frame.active index end]>3} {
	$ds9(mb).frame.active delete 4 end
    }

    foreach f $ds9(frames) {
	$ds9(mb).frame add radiobutton -label $f \
	    -variable ds9(next) -value $f -command GotoFrame
	$ds9(mb).frame.active add checkbutton -label $f \
	    -variable active($f) -command UpdateActiveFrames
    }
}

