#  Copyright (C) 1999-2005
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc RegionMenu {} {
    global ds9
    global menu

    set menu(region,show) [msgcat::mc "Show Regions"]
    set menu(region,show,text) [msgcat::mc "Show Regions Text"]
    set menu(region,info) [msgcat::mc "Get Info..."]
    set menu(region,shape) [msgcat::mc "Shape"]
    set menu(region,color) [msgcat::mc "Color"]
    set menu(region,width) [msgcat::mc "Width"]
    set menu(region,prop) [msgcat::mc "Properties"]
    set menu(region,font) [msgcat::mc "Font"]
    set menu(region,tofront) [msgcat::mc "Move to Front"]
    set menu(region,toback) [msgcat::mc "Move to Back"]
    set menu(region,select,all) [msgcat::mc "Select All"]
    set menu(region,select,none) [msgcat::mc "Select None"]
    set menu(region,select,invert) [msgcat::mc "Invert Selection"]
    set menu(region,delete,select) [msgcat::mc "Delete Selected Regions"]
    set menu(region,delete,all) [msgcat::mc "Delete All Regions"]
    set menu(region,group,new) [msgcat::mc "New Group"]
    set menu(region,group) [msgcat::mc "Groups..."]
    set menu(region,composite,new) [msgcat::mc "Create Composite Region"]
    set menu(region,composite,delete) [msgcat::mc "Dissolve Composite Region"]
    set menu(region,template,load) [msgcat::mc "Load Template..."]
    set menu(region,template,save) [msgcat::mc "Save as Template..."]
    set menu(region,list) [msgcat::mc "List Regions"]
    set menu(region,load) [msgcat::mc "Load Regions..."]
    set menu(region,save) [msgcat::mc "Save Regions..."]
    set menu(region,file) [msgcat::mc "File Format"]
    set menu(region,wcs) [msgcat::mc "File Coordinate System"]

    set menu(region,shape,fov) [msgcat::mc "Instrument FOV"]

    set menu(region,prop,edit) [msgcat::mc "Can Edit"]
    set menu(region,prop,move) [msgcat::mc "Can Move"]
    set menu(region,prop,rotate) [msgcat::mc "Can Rotate"]
    set menu(region,prop,delete) [msgcat::mc "Can Delete"]
    set menu(region,prop,fixed) [msgcat::mc "Fixed in Size"]
    set menu(region,prop,include) [msgcat::mc "Include"]
    set menu(region,prop,exclude) [msgcat::mc "Exclude"]
    set menu(region,prop,source) [msgcat::mc "Source"]
    set menu(region,prop,bg) [msgcat::mc "Background"]

    set menu(region,format,ds9) [msgcat::mc "DS9/Funtools"]
    set menu(region,format,ciao) [msgcat::mc "Ciao"]
    set menu(region,format,saotng) [msgcat::mc "SAOtng"]
    set menu(region,format,saoimage) [msgcat::mc "SAOimage"]
    set menu(region,format,pros) [msgcat::mc "IRAF PROS"]
    set menu(region,format,xy) [msgcat::mc "X Y"]
    set menu(region,format,strip) [msgcat::mc "Strip Output"]
    set menu(region,format,list) [msgcat::mc "List WCS"]

    menu $ds9(mb).region -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Region"
    $ds9(mb).region add checkbutton -label $menu(region,show) \
	-variable marker(show) -command MarkerShow
    $ds9(mb).region add checkbutton -label $menu(region,show,text) \
	-variable marker(show,text) -command MarkerShowText
    $ds9(mb).region add separator
    $ds9(mb).region add command -label $menu(region,info) \
	-command MarkerInfo
    $ds9(mb).region add separator
    $ds9(mb).region add cascade -label $menu(region,shape) \
	-menu $ds9(mb).region.shape
    $ds9(mb).region add cascade -label $menu(region,color) \
	-menu $ds9(mb).region.color
    $ds9(mb).region add cascade -label $menu(region,width) \
	-menu $ds9(mb).region.width
    $ds9(mb).region add cascade -label $menu(region,prop) \
	-menu $ds9(mb).region.properties
    $ds9(mb).region add cascade -label $menu(region,font) \
	-menu $ds9(mb).region.font
    $ds9(mb).region add separator
    $ds9(mb).region add command -label $menu(region,tofront) \
	-command MarkerFront
    $ds9(mb).region add command -label $menu(region,toback) \
	-command MarkerBack
    $ds9(mb).region add separator
    $ds9(mb).region add command -label $menu(region,select,all) \
	-command MarkerSelectAll
    $ds9(mb).region add command -label $menu(region,select,none) \
	-command MarkerUnselectAll
    $ds9(mb).region add command -label $menu(region,select,invert) \
	-command MarkerSelectInvert
    $ds9(mb).region add separator
    $ds9(mb).region add command -label $menu(region,delete,select) \
	-command MarkerDeleteSelect
    $ds9(mb).region add command -label $menu(region,delete,all) \
	-command MarkerDeleteAllMenu
    $ds9(mb).region add separator
    $ds9(mb).region add command -label $menu(region,group,new) \
	-command GroupCreate
    $ds9(mb).region add command -label $menu(region,group) \
	-command GroupDialog
    $ds9(mb).region add separator
    $ds9(mb).region add command -label $menu(region,composite,new) \
	-command CompositeCreate
    $ds9(mb).region add command -label $menu(region,composite,delete) \
	-command CompositeDelete
    $ds9(mb).region add separator
    $ds9(mb).region add command -label $menu(region,template,load) \
	-command OpenTemplateMarker
    $ds9(mb).region add command -label $menu(region,template,save) \
	-command SaveAsTemplateMarker
    $ds9(mb).region add separator
    $ds9(mb).region add command -label $menu(region,list) \
	-command MarkerDisplay
    $ds9(mb).region add command -label $menu(region,load) \
	-command MarkerOpen
    $ds9(mb).region add command -label $menu(region,save) \
	-command MarkerSave
    $ds9(mb).region add separator
    $ds9(mb).region add cascade -label $menu(region,file) \
	-menu $ds9(mb).region.format
    $ds9(mb).region add cascade -label $menu(region,wcs) \
	-menu $ds9(mb).region.coord

    menu $ds9(mb).region.shape -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Region Shape"
    $ds9(mb).region.shape add radiobutton -label $menu(shape,circle) \
	-variable marker(shape) -value circle
    $ds9(mb).region.shape add radiobutton -label $menu(shape,ellipse) \
	-variable marker(shape) -value ellipse
    $ds9(mb).region.shape add radiobutton -label $menu(shape,box) \
	-variable marker(shape) -value box
    $ds9(mb).region.shape add radiobutton -label $menu(shape,polygon) \
	-variable marker(shape) -value polygon
    $ds9(mb).region.shape add radiobutton -label $menu(shape,line) \
	-variable marker(shape) -value line
    $ds9(mb).region.shape add radiobutton -label $menu(shape,vector) \
	-variable marker(shape) -value vector
    $ds9(mb).region.shape add radiobutton -label $menu(shape,text) \
	-variable marker(shape) -value text
    $ds9(mb).region.shape add separator
    $ds9(mb).region.shape add radiobutton -label $menu(shape,ruler) \
	-variable marker(shape) -value ruler
    $ds9(mb).region.shape add radiobutton -label $menu(shape,compass) \
	-variable marker(shape) -value compass
    $ds9(mb).region.shape add radiobutton -label $menu(shape,projection) \
	-variable marker(shape) -value projection
    $ds9(mb).region.shape add separator
    $ds9(mb).region.shape add radiobutton -label $menu(shape,annulus) \
	-variable marker(shape) -value annulus
    $ds9(mb).region.shape add radiobutton \
	-label $menu(shape,annulus,ellipse) \
	-variable marker(shape) -value ellipseannulus
    $ds9(mb).region.shape add radiobutton -label $menu(shape,annulus,box) \
	-variable marker(shape) -value boxannulus
    $ds9(mb).region.shape add radiobutton -label $menu(shape,panda) \
	-variable marker(shape) -value panda
    $ds9(mb).region.shape add radiobutton -label $menu(shape,panda,ellipse)\
	-variable marker(shape) -value epanda
    $ds9(mb).region.shape add radiobutton -label $menu(shape,panda,box) \
	-variable marker(shape) -value bpanda
    $ds9(mb).region.shape add separator
    $ds9(mb).region.shape add radiobutton -label $menu(shape,point,circle) \
	-variable marker(shape) -value "circle point" 
    $ds9(mb).region.shape add radiobutton -label $menu(shape,point,box) \
	-variable marker(shape) -value "box point"
    $ds9(mb).region.shape add radiobutton -label $menu(shape,point,diamond) \
	-variable marker(shape) -value "diamond point"
    $ds9(mb).region.shape add radiobutton -label $menu(shape,point,cross) \
	-variable marker(shape) -value "cross point"
    $ds9(mb).region.shape add radiobutton -label $menu(shape,point,x) \
	-variable marker(shape) -value "x point"
    $ds9(mb).region.shape add radiobutton -label $menu(shape,point,arrow) \
	-variable marker(shape) -value "arrow point" 
    $ds9(mb).region.shape add radiobutton -label $menu(shape,point,boxcircle) \
	-variable marker(shape) -value "boxcircle point"
    $ds9(mb).region.shape add separator
    $ds9(mb).region.shape add cascade -label $menu(region,shape,fov) \
	-menu $ds9(mb).region.shape.template

    CreateTemplateMenu

    menu $ds9(mb).region.color -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Region Color"
    $ds9(mb).region.color add radiobutton -label $menu(color,black) \
	-variable marker(color) -value black -command MarkerColor
    $ds9(mb).region.color add radiobutton -label $menu(color,white) \
	-variable marker(color) -value white -command MarkerColor
    $ds9(mb).region.color add radiobutton -label $menu(color,red) \
	-variable marker(color) -value red -command MarkerColor
    $ds9(mb).region.color add radiobutton -label $menu(color,green) \
	-variable marker(color) -value green -command MarkerColor
    $ds9(mb).region.color add radiobutton -label $menu(color,blue) \
	-variable marker(color) -value blue -command MarkerColor
    $ds9(mb).region.color add radiobutton -label $menu(color,cyan) \
	-variable marker(color) -value cyan -command MarkerColor
    $ds9(mb).region.color add radiobutton -label $menu(color,magenta) \
	-variable marker(color) -value magenta -command MarkerColor
    $ds9(mb).region.color add radiobutton -label $menu(color,yellow) \
	-variable marker(color) -value yellow -command MarkerColor

    menu $ds9(mb).region.width -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Region Width"
    $ds9(mb).region.width add radiobutton -label "1" \
	-variable marker(width) -value 1 -command MarkerWidth
    $ds9(mb).region.width add radiobutton -label "2" \
	-variable marker(width) -value 2 -command MarkerWidth
    $ds9(mb).region.width add radiobutton -label "3" \
	-variable marker(width) -value 3 -command MarkerWidth
    $ds9(mb).region.width add radiobutton -label "4" \
	-variable marker(width) -value 4 -command MarkerWidth

    menu $ds9(mb).region.properties -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Region Properties"
    $ds9(mb).region.properties add checkbutton \
	-label $menu(region,prop,edit) \
	-variable marker(edit) -command {MarkerProp edit}
    $ds9(mb).region.properties add checkbutton \
	-label $menu(region,prop,move) \
	-variable marker(move) -command {MarkerProp move}
    $ds9(mb).region.properties add checkbutton \
	-label $menu(region,prop,rotate) \
	-variable marker(rotate) -command {MarkerProp rotate}
    $ds9(mb).region.properties add checkbutton \
	-label $menu(region,prop,delete) \
	-variable marker(delete) -command {MarkerProp delete}
    $ds9(mb).region.properties add checkbutton \
	-label $menu(region,prop,fixed) \
	-variable marker(fixed) -command {MarkerProp fixed}
    $ds9(mb).region.properties add separator
    $ds9(mb).region.properties add radiobutton \
	-label $menu(region,prop,include) \
	-variable marker(include) -value 1 -command {MarkerProp include}
    $ds9(mb).region.properties add radiobutton \
	-label $menu(region,prop,exclude) \
	-variable marker(include) -value 0 -command {MarkerProp include}
    $ds9(mb).region.properties add separator
    $ds9(mb).region.properties add radiobutton \
	-label $menu(region,prop,source) \
	-variable marker(source) -value 1 -command {MarkerProp source}
    $ds9(mb).region.properties add radiobutton \
	-label $menu(region,prop,bg) \
	-variable marker(source) -value 0 -command {MarkerProp source}

    menu $ds9(mb).region.font -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Region Font"
    $ds9(mb).region.font add radiobutton -label $menu(font,times) \
	-variable marker(font) -value times -command MarkerFont
    $ds9(mb).region.font add radiobutton -label $menu(font,helvetica) \
	-variable marker(font) -value helvetica -command MarkerFont
    $ds9(mb).region.font add radiobutton -label $menu(font,symbol) \
	-variable marker(font) -value symbol -command MarkerFont
    $ds9(mb).region.font add radiobutton -label $menu(font,courier) \
	-variable marker(font) -value courier -command MarkerFont
    $ds9(mb).region.font add separator
    $ds9(mb).region.font add radiobutton -label "9" \
	-variable marker(font,size) -value 9 -command MarkerFont
    $ds9(mb).region.font add radiobutton -label "10" \
	-variable marker(font,size) -value 10 -command MarkerFont
    $ds9(mb).region.font add radiobutton -label "12" \
	-variable marker(font,size) -value 12 -command MarkerFont
    $ds9(mb).region.font add radiobutton -label "14" \
	-variable marker(font,size) -value 14 -command MarkerFont
    $ds9(mb).region.font add radiobutton -label "18" \
	-variable marker(font,size) -value 18 -command MarkerFont
    $ds9(mb).region.font add radiobutton -label "24" \
	-variable marker(font,size) -value 24 -command MarkerFont
    $ds9(mb).region.font add radiobutton -label "30" \
	-variable marker(font,size) -value 30 -command MarkerFont
    $ds9(mb).region.font add radiobutton -label "36" \
	-variable marker(font,size) -value 36 -command MarkerFont
    $ds9(mb).region.font add separator
    $ds9(mb).region.font add radiobutton -label $menu(font,plain) \
	-variable marker(font,style) -value normal -command MarkerFont
    $ds9(mb).region.font add radiobutton -label $menu(font,bold) \
	-variable marker(font,style) -value bold -command MarkerFont
    $ds9(mb).region.font add radiobutton -label $menu(font,italic) \
	-variable marker(font,style) -value italic -command MarkerFont

    menu $ds9(mb).region.format -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Region Format"
    $ds9(mb).region.format add radiobutton -label $menu(region,format,ds9) \
	-variable marker(format) -value ds9 -command UpdateMarkerFormatMenu
    $ds9(mb).region.format add radiobutton -label $menu(region,format,ciao) \
	-variable marker(format) -value ciao -command UpdateMarkerFormatMenu
    $ds9(mb).region.format add radiobutton -label $menu(region,format,saotng) \
	-variable marker(format) -value saotng -command UpdateMarkerFormatMenu
    $ds9(mb).region.format add radiobutton \
	-label $menu(region,format,saoimage) \
	-variable marker(format) -value saoimage \
	-command UpdateMarkerFormatMenu
    $ds9(mb).region.format add radiobutton -label $menu(region,format,pros) \
	-variable marker(format) -value pros -command UpdateMarkerFormatMenu
    $ds9(mb).region.format add radiobutton -label $menu(region,format,xy) \
	-variable marker(format) -value xy -command UpdateMarkerFormatMenu
    $ds9(mb).region.format add separator
    $ds9(mb).region.format add checkbutton -label $menu(region,format,strip) \
	-variable marker(strip)
    $ds9(mb).region.format add checkbutton -label $menu(region,format,list) \
	-variable marker(wcs)

    menu $ds9(mb).region.coord -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Region Coordinate"
    $ds9(mb).region.coord add radiobutton \
	-label $menu(wcs) \
	-variable marker(system) -value wcs \
	-command UpdateMarkerFormatMenu
    $ds9(mb).region.coord add cascade \
	-label $menu(wcs,multi) \
	-menu $ds9(mb).region.coord.wcs
    $ds9(mb).region.coord add separator
    $ds9(mb).region.coord add radiobutton \
	-label $menu(wcs,image) \
	-variable marker(system) -value image \
	-command UpdateMarkerFormatMenu
    $ds9(mb).region.coord add radiobutton \
	-label $menu(wcs,physical) \
	-variable marker(system) -value physical \
	-command UpdateMarkerFormatMenu
    $ds9(mb).region.coord add radiobutton \
	-label $menu(wcs,amplifier) \
	-variable marker(system) -value amplifier \
	-command UpdateMarkerFormatMenu
    $ds9(mb).region.coord add radiobutton \
    -label $menu(wcs,detector) \
	-variable marker(system) -value detector \
	-command UpdateMarkerFormatMenu
    $ds9(mb).region.coord add separator
    $ds9(mb).region.coord add radiobutton \
	-label $menu(wcs,fk4) \
	-variable marker(sky) -value fk4
    $ds9(mb).region.coord add radiobutton \
	-label $menu(wcs,fk5) \
	-variable marker(sky) -value fk5
    $ds9(mb).region.coord add radiobutton \
	-label $menu(wcs,icrs) \
	-variable marker(sky) -value icrs
    $ds9(mb).region.coord add radiobutton \
	-label $menu(wcs,galactic) \
	-variable marker(sky) -value galactic
    $ds9(mb).region.coord add radiobutton \
	-label $menu(wcs,ecliptic) \
	-variable marker(sky) -value ecliptic
    $ds9(mb).region.coord add separator
    $ds9(mb).region.coord add radiobutton \
	-label $menu(wcs,degrees) \
	-variable marker(skyformat) -value degrees
    $ds9(mb).region.coord add radiobutton \
	-label $menu(wcs,sexagesimal) \
	-variable marker(skyformat) -value sexagesimal

    menu $ds9(mb).region.coord.wcs -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	$ds9(mb).region.coord.wcs add radiobutton \
	    -label "$menu(wcs) $l" \
	    -variable marker(system) -value "wcs$l" \
	    -command UpdateMarkerFormatMenu
    }

    RegionPrefsMenu
}

proc RegionPrefsMenu {} {
    global ds9
    global menu
    global prefs

    set menu(prefs,region,default) [msgcat::mc "Default Dialog"]
    set menu(prefs,region,coord) [msgcat::mc "Coordinate System"]
    set menu(prefs,region,dist) [msgcat::mc "Distance System"]

    menu $ds9(mb).prefs.gui.region -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.gui.region add cascade -label $menu(region,shape) \
	-menu $ds9(mb).prefs.gui.region.shape
    $ds9(mb).prefs.gui.region add cascade -label $menu(region,color) \
	-menu $ds9(mb).prefs.gui.region.color
    $ds9(mb).prefs.gui.region add cascade -label $menu(region,width) \
	-menu $ds9(mb).prefs.gui.region.width
    $ds9(mb).prefs.gui.region add cascade -label $menu(region,prop) \
	-menu $ds9(mb).prefs.gui.region.properties
    $ds9(mb).prefs.gui.region add cascade -label $menu(region,font) \
	-menu $ds9(mb).prefs.gui.region.font
    $ds9(mb).prefs.gui.region add separator
    $ds9(mb).prefs.gui.region add command -label $menu(shape,circle) \
	-command PrefsMarkerCircle
    $ds9(mb).prefs.gui.region add command -label $menu(shape,ellipse) \
	-command PrefsMarkerEllipse
    $ds9(mb).prefs.gui.region add command -label $menu(shape,box) \
	-command PrefsMarkerBox
    $ds9(mb).prefs.gui.region add command -label $menu(shape,projection) \
	-command PrefsMarkerProjection
    $ds9(mb).prefs.gui.region add separator
    $ds9(mb).prefs.gui.region add command -label $menu(shape,annulus) \
	-command PrefsMarkerAnnulus
    $ds9(mb).prefs.gui.region add command -label $menu(shape,annulus,ellipse) \
	-command PrefsMarkerEllipseAnnulus
    $ds9(mb).prefs.gui.region add command -label $menu(shape,annulus,box) \
	-command PrefsMarkerBoxAnnulus
    $ds9(mb).prefs.gui.region add command -label $menu(shape,panda) \
	-command PrefsMarkerPanda
    $ds9(mb).prefs.gui.region add command -label $menu(shape,panda,ellipse) \
	-command PrefsMarkerEpanda
    $ds9(mb).prefs.gui.region add command -label $menu(shape,panda,box) \
	-command PrefsMarkerBpanda
    $ds9(mb).prefs.gui.region add separator
    $ds9(mb).prefs.gui.region add cascade -label $menu(region,file) \
	-menu $ds9(mb).prefs.gui.region.format
    $ds9(mb).prefs.gui.region add cascade -label $menu(region,wcs) \
	-menu $ds9(mb).prefs.gui.region.coord
    $ds9(mb).prefs.gui.region add separator
    $ds9(mb).prefs.gui.region add cascade -label $menu(prefs,region,default) \
	-menu $ds9(mb).prefs.gui.region.dialog

    menu $ds9(mb).prefs.gui.region.shape -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label $menu(shape,circle) \
	-variable prefs(marker,shape) -value circle -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label $menu(shape,ellipse) \
	-variable prefs(marker,shape) -value ellipse -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label $menu(shape,box) \
	-variable prefs(marker,shape) -value box -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label $menu(shape,polygon) \
	-variable prefs(marker,shape) -value polygon -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label $menu(shape,line) \
	-variable prefs(marker,shape) -value line -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label $menu(shape,vector) \
	-variable prefs(marker,shape) -value vector -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label $menu(shape,text) \
	-variable prefs(marker,shape) -value text -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add separator
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label $menu(shape,ruler) \
	-variable prefs(marker,shape) -value ruler -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label $menu(shape,compass) \
	-variable prefs(marker,shape) -value compass -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label $menu(shape,projection) \
	-variable prefs(marker,shape) -value projection -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add separator
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label $menu(shape,annulus) \
	-variable prefs(marker,shape) -value annulus -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label $menu(shape,annulus,ellipse) \
	-variable prefs(marker,shape) -value ellipseannulus -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label $menu(shape,annulus,box) \
	-variable prefs(marker,shape) -value boxannulus -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label $menu(shape,panda) \
	-variable prefs(marker,shape) -value panda -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label $menu(shape,panda,ellipse) \
	-variable prefs(marker,shape) -value epanda -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label $menu(shape,panda,box) \
	-variable prefs(marker,shape) -value bpanda -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add separator
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label $menu(shape,point,circle) \
	-variable prefs(marker,shape) -value {circle point} -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label $menu(shape,point,box) \
	-variable prefs(marker,shape) -value {box point}  -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label $menu(shape,point,diamond) \
	-variable prefs(marker,shape) -value {diamond point} -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label $menu(shape,point,cross) \
	-variable prefs(marker,shape) -value {cross point} -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label $menu(shape,point,x) \
	-variable prefs(marker,shape) -value {x point} -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label $menu(shape,point,arrow) \
	-variable prefs(marker,shape) -value {arrow point} -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label $menu(shape,point,boxcircle) \
	-variable prefs(marker,shape) -value {boxcircle point} \
	-command SavePrefs

    menu $ds9(mb).prefs.gui.region.color -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.gui.region.color add radiobutton -label $menu(color,black) \
	-variable prefs(marker,color) -value black -command SavePrefs
    $ds9(mb).prefs.gui.region.color add radiobutton -label $menu(color,white) \
	-variable prefs(marker,color) -value white -command SavePrefs
    $ds9(mb).prefs.gui.region.color add radiobutton -label $menu(color,red) \
	-variable prefs(marker,color) -value red -command SavePrefs
    $ds9(mb).prefs.gui.region.color add radiobutton -label $menu(color,green) \
	-variable prefs(marker,color) -value green -command SavePrefs
    $ds9(mb).prefs.gui.region.color add radiobutton -label $menu(color,blue) \
	-variable prefs(marker,color) -value blue -command SavePrefs
    $ds9(mb).prefs.gui.region.color add radiobutton -label $menu(color,cyan) \
	-variable prefs(marker,color) -value cyan -command SavePrefs
    $ds9(mb).prefs.gui.region.color add radiobutton -label $menu(color,magenta) \
	-variable prefs(marker,color) -value magenta -command SavePrefs
    $ds9(mb).prefs.gui.region.color add radiobutton -label $menu(color,yellow) \
	-variable prefs(marker,color) -value yellow -command SavePrefs

    menu $ds9(mb).prefs.gui.region.width -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Region Width"
    $ds9(mb).prefs.gui.region.width add radiobutton -label "1" \
	-variable prefs(marker,width) -value 1 -command SavePrefs
    $ds9(mb).prefs.gui.region.width add radiobutton -label "2" \
	-variable prefs(marker,width) -value 2 -command SavePrefs
    $ds9(mb).prefs.gui.region.width add radiobutton -label "3" \
	-variable prefs(marker,width) -value 3 -command SavePrefs
    $ds9(mb).prefs.gui.region.width add radiobutton -label "4" \
	-variable prefs(marker,width) -value 4 -command SavePrefs

    menu $ds9(mb).prefs.gui.region.properties -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Region Properties"
    $ds9(mb).prefs.gui.region.properties add checkbutton \
	-label $menu(region,prop,edit) \
	-variable prefs(marker,edit) -command SavePrefs
    $ds9(mb).prefs.gui.region.properties add checkbutton \
	-label $menu(region,prop,move) \
	-variable prefs(marker,move) -command SavePrefs
    $ds9(mb).prefs.gui.region.properties add checkbutton \
	-label $menu(region,prop,rotate) \
	-variable prefs(marker,rotate) -command SavePrefs
    $ds9(mb).prefs.gui.region.properties add checkbutton \
	-label $menu(region,prop,delete) \
	-variable prefs(marker,delete) -command SavePrefs
    $ds9(mb).prefs.gui.region.properties add checkbutton \
	-label $menu(region,prop,fixed) \
	-variable prefs(marker,fixed) -command SavePrefs

    $ds9(mb).prefs.gui.region.properties add separator
    $ds9(mb).prefs.gui.region.properties add radiobutton \
	-label $menu(region,prop,include) \
	-variable prefs(marker,include) -value 1 -command SavePrefs
    $ds9(mb).prefs.gui.region.properties add radiobutton \
	-label $menu(region,prop,exclude) \
	-variable prefs(marker,include) -value 0 -command SavePrefs
    $ds9(mb).prefs.gui.region.properties add separator
    $ds9(mb).prefs.gui.region.properties add radiobutton \
	-label $menu(region,prop,source) \
	-variable prefs(marker,source) -value 1 -command SavePrefs
    $ds9(mb).prefs.gui.region.properties add radiobutton \
	-label $menu(region,prop,bg) \
	-variable prefs(marker,source) -value 0 -command SavePrefs

    menu $ds9(mb).prefs.gui.region.font -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Region Font"
    $ds9(mb).prefs.gui.region.font add radiobutton -label $menu(font,times) \
	-variable prefs(marker,font) -value times -command SavePrefs
    $ds9(mb).prefs.gui.region.font add radiobutton -label $menu(font,helvetica) \
	-variable prefs(marker,font) -value helvetica -command SavePrefs
    $ds9(mb).prefs.gui.region.font add radiobutton -label $menu(font,symbol) \
	-variable prefs(marker,font) -value symbol -command SavePrefs
    $ds9(mb).prefs.gui.region.font add radiobutton -label $menu(font,courier) \
	-variable prefs(marker,font) -value courier -command SavePrefs
    $ds9(mb).prefs.gui.region.font add separator
    $ds9(mb).prefs.gui.region.font add radiobutton -label "9" \
	-variable prefs(marker,font,size) -value 9 -command SavePrefs
    $ds9(mb).prefs.gui.region.font add radiobutton -label "10" \
	-variable prefs(marker,font,size) -value 10 -command SavePrefs
    $ds9(mb).prefs.gui.region.font add radiobutton -label "12" \
	-variable prefs(marker,font,size) -value 12 -command SavePrefs
    $ds9(mb).prefs.gui.region.font add radiobutton -label "14" \
	-variable prefs(marker,font,size) -value 14 -command SavePrefs
    $ds9(mb).prefs.gui.region.font add radiobutton -label "18" \
	-variable prefs(marker,font,size) -value 18 -command SavePrefs
    $ds9(mb).prefs.gui.region.font add radiobutton -label "24" \
	-variable prefs(marker,font,size) -value 24 -command SavePrefs
    $ds9(mb).prefs.gui.region.font add radiobutton -label "30" \
	-variable prefs(marker,font,size) -value 30 -command SavePrefs
    $ds9(mb).prefs.gui.region.font add radiobutton -label "36" \
	-variable prefs(marker,font,size) -value 36 -command SavePrefs
    $ds9(mb).prefs.gui.region.font add separator
    $ds9(mb).prefs.gui.region.font add radiobutton -label $menu(font,plain) \
	-variable prefs(marker,font,style) -value normal -command SavePrefs
    $ds9(mb).prefs.gui.region.font add radiobutton -label $menu(font,bold) \
	-variable prefs(marker,font,style) -value bold -command SavePrefs
    $ds9(mb).prefs.gui.region.font add radiobutton -label $menu(font,italic) \
	-variable prefs(marker,font,style) -value italic -command SavePrefs

    menu $ds9(mb).prefs.gui.region.format -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.gui.region.format add radiobutton \
	-label $menu(region,format,ds9) \
	-variable prefs(marker,format) -value ds9 \
	-command PrefsMarkerFormat
    $ds9(mb).prefs.gui.region.format add radiobutton \
	-label $menu(region,format,ciao) \
	-variable prefs(marker,format) -value ciao \
	-command PrefsMarkerFormat
    $ds9(mb).prefs.gui.region.format add radiobutton \
	-label $menu(region,format,saotng) \
	-variable prefs(marker,format) -value saotng \
	-command PrefsMarkerFormat
    $ds9(mb).prefs.gui.region.format add radiobutton \
	-label $menu(region,format,saoimage) \
	-variable prefs(marker,format) -value saoimage \
	-command PrefsMarkerFormat
    $ds9(mb).prefs.gui.region.format add radiobutton \
	-label $menu(region,format,pros) \
	-variable prefs(marker,format) -value pros \
	-command PrefsMarkerFormat
    $ds9(mb).prefs.gui.region.format add radiobutton \
	-label $menu(region,format,xy) \
	-variable prefs(marker,format) -value xy \
	-command PrefsMarkerFormat
    $ds9(mb).prefs.gui.region.format add separator
    $ds9(mb).prefs.gui.region.format add checkbutton \
	-label $menu(region,format,strip) \
	-variable prefs(marker,strip)
    $ds9(mb).prefs.gui.region.format add checkbutton \
	-label $menu(region,format,list) \
	-variable prefs(marker,wcs)

    menu $ds9(mb).prefs.gui.region.coord -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.gui.region.coord add radiobutton -label $menu(wcs) \
	-variable prefs(marker,system) -value wcs -command SavePrefs
    $ds9(mb).prefs.gui.region.coord add cascade -label $menu(wcs,multi) \
	-menu $ds9(mb).prefs.gui.region.coord.wcs
    $ds9(mb).prefs.gui.region.coord add separator
    $ds9(mb).prefs.gui.region.coord add radiobutton -label $menu(wcs,image) \
	-variable prefs(marker,system) -value image -command SavePrefs
    $ds9(mb).prefs.gui.region.coord add radiobutton -label $menu(wcs,physical) \
	-variable prefs(marker,system) -value physical -command SavePrefs
    $ds9(mb).prefs.gui.region.coord add radiobutton -label $menu(wcs,amplifier) \
	-variable prefs(marker,system) -value amplifier -command SavePrefs
    $ds9(mb).prefs.gui.region.coord add radiobutton -label $menu(wcs,detector) \
	-variable prefs(marker,system) -value detector -command SavePrefs
    $ds9(mb).prefs.gui.region.coord add separator
    $ds9(mb).prefs.gui.region.coord add radiobutton -label $menu(wcs,fk4) \
	-variable prefs(marker,sky) -value fk4 -command SavePrefs
    $ds9(mb).prefs.gui.region.coord add radiobutton -label $menu(wcs,fk5) \
	-variable prefs(marker,sky) -value fk5 -command SavePrefs
    $ds9(mb).prefs.gui.region.coord add radiobutton -label $menu(wcs,icrs) \
	-variable prefs(marker,sky) -value icrs -command SavePrefs
    $ds9(mb).prefs.gui.region.coord add radiobutton -label $menu(wcs,galactic) \
	-variable prefs(marker,sky) -value galactic -command SavePrefs
    $ds9(mb).prefs.gui.region.coord add radiobutton -label $menu(wcs,ecliptic) \
	-variable prefs(marker,sky) -value ecliptic -command SavePrefs
    $ds9(mb).prefs.gui.region.coord add separator
    $ds9(mb).prefs.gui.region.coord add radiobutton -label $menu(wcs,degrees) \
	-variable prefs(marker,skyformat) -value degrees -command SavePrefs
    $ds9(mb).prefs.gui.region.coord add radiobutton -label $menu(wcs,sexagesimal) \
	-variable prefs(marker,skyformat) -value sexagesimal -command SavePrefs

    menu $ds9(mb).prefs.gui.region.coord.wcs -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	$ds9(mb).prefs.gui.region.coord.wcs add radiobutton \
	    -label "$menu(wcs) $l" \
	    -variable prefs(marker,system) -value "wcs$l" -command SavePrefs
    }

    menu $ds9(mb).prefs.gui.region.dialog -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.gui.region.dialog add cascade \
	-label $menu(prefs,region,coord) \
	-menu $ds9(mb).prefs.gui.region.dialog.sys
    $ds9(mb).prefs.gui.region.dialog add cascade \
	-label $menu(prefs,region,dist) \
	-menu $ds9(mb).prefs.gui.region.dialog.dist

    menu $ds9(mb).prefs.gui.region.dialog.sys -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.gui.region.dialog.sys add radiobutton -label $menu(wcs) \
	-variable marker(dialog,system) -value wcs -command SavePrefs
    $ds9(mb).prefs.gui.region.dialog.sys add cascade \
	-label $menu(wcs,multi) \
	-menu $ds9(mb).prefs.gui.region.dialog.sys.wcs
    $ds9(mb).prefs.gui.region.dialog.sys add separator
    $ds9(mb).prefs.gui.region.dialog.sys add radiobutton \
	-label $menu(wcs,image) \
	-variable marker(dialog,system) -value image -command SavePrefs
    $ds9(mb).prefs.gui.region.dialog.sys add radiobutton \
	-label $menu(wcs,physical) \
	-variable marker(dialog,system) -value physical -command SavePrefs
    $ds9(mb).prefs.gui.region.dialog.sys add radiobutton \
	-label $menu(wcs,amplifier) \
	-variable marker(dialog,system) -value amplifier -command SavePrefs
    $ds9(mb).prefs.gui.region.dialog.sys add radiobutton \
	-label $menu(wcs,detector) \
	-variable marker(dialog,system) -value detector -command SavePrefs
    $ds9(mb).prefs.gui.region.dialog.sys add separator
    $ds9(mb).prefs.gui.region.dialog.sys add radiobutton \
	-label $menu(wcs,fk4) \
	-variable marker(dialog,sky) -value fk4 -command SavePrefs
    $ds9(mb).prefs.gui.region.dialog.sys add radiobutton \
	-label $menu(wcs,fk5) \
	-variable marker(dialog,sky) -value fk5 -command SavePrefs
    $ds9(mb).prefs.gui.region.dialog.sys add radiobutton \
	-label $menu(wcs,icrs) \
	-variable marker(dialog,sky) -value icrs -command SavePrefs
    $ds9(mb).prefs.gui.region.dialog.sys add radiobutton \
	-label $menu(wcs,galactic) \
	-variable marker(dialog,sky) -value galactic -command SavePrefs
    $ds9(mb).prefs.gui.region.dialog.sys add radiobutton \
	-label $menu(wcs,ecliptic) \
	-variable marker(dialog,sky) -value ecliptic -command SavePrefs
    $ds9(mb).prefs.gui.region.dialog.sys add separator
    $ds9(mb).prefs.gui.region.dialog.sys add radiobutton \
	-label $menu(wcs,degrees) \
	-variable marker(dialog,skyformat) -value degrees -command SavePrefs
    $ds9(mb).prefs.gui.region.dialog.sys add radiobutton \
	-label $menu(wcs,sexagesimal) \
	-variable marker(dialog,skyformat) -value sexagesimal \
	-command SavePrefs

    menu $ds9(mb).prefs.gui.region.dialog.sys.wcs -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	$ds9(mb).prefs.gui.region.dialog.sys.wcs add radiobutton \
	    -label "$menu(wcs) $l" \
	    -variable marker(dialog,system) -value "wcs$l" -command SavePrefs
    }

    menu $ds9(mb).prefs.gui.region.dialog.dist -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.gui.region.dialog.dist add radiobutton \
	-label $menu(wcs) \
	-variable marker(dialog,dist,system) -value wcs -command SavePrefs
    $ds9(mb).prefs.gui.region.dialog.dist add cascade \
	-label $menu(wcs,multi) \
	-menu $ds9(mb).prefs.gui.region.dialog.dist.wcs
    $ds9(mb).prefs.gui.region.dialog.dist add separator
    $ds9(mb).prefs.gui.region.dialog.dist add radiobutton \
	-label $menu(wcs,image) \
	-variable marker(dialog,dist,system) -value image -command SavePrefs
    $ds9(mb).prefs.gui.region.dialog.dist add radiobutton \
	-label $menu(wcs,physical) \
	-variable marker(dialog,dist,system) -value physical -command SavePrefs
    $ds9(mb).prefs.gui.region.dialog.dist add radiobutton \
	-label $menu(wcs,amplifier) \
	-variable marker(dialog,dist,system) -value amplifier \
	-command SavePrefs
    $ds9(mb).prefs.gui.region.dialog.dist add radiobutton \
	-label $menu(wcs,detector) \
	-variable marker(dialog,dist,system) -value detector -command SavePrefs
    $ds9(mb).prefs.gui.region.dialog.dist add separator
    $ds9(mb).prefs.gui.region.dialog.dist add radiobutton \
	-label $menu(wcs,degrees) \
	-variable marker(dialog,dist,format) -value degrees -command SavePrefs
    $ds9(mb).prefs.gui.region.dialog.dist add radiobutton \
	-label $menu(wcs,arcmin) \
	-variable marker(dialog,dist,format) -value arcmin -command SavePrefs
    $ds9(mb).prefs.gui.region.dialog.dist add radiobutton \
	-label $menu(wcs,arcsec) \
	-variable marker(dialog,dist,format) -value arcsec -command SavePrefs

    menu $ds9(mb).prefs.gui.region.dialog.dist.wcs -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	$ds9(mb).prefs.gui.region.dialog.dist.wcs add radiobutton \
	    -label "$menu(wcs) $l" \
	    -variable marker(dialog,dist,system) -value "wcs$l" \
	    -command SavePrefs
    }
}

proc RegionButtons {} {
    global ds9
    global buttons

    set buttons(region,info) [msgcat::mc "info"]
    set buttons(region,front) [msgcat::mc "front"]
    set buttons(region,back) [msgcat::mc "back"]
    set buttons(region,all) [msgcat::mc "all"]
    set buttons(region,none) [msgcat::mc "none"]
    set buttons(region,invert) [msgcat::mc "invert"]
    set buttons(region,del) [msgcat::mc "del"]
    set buttons(region,delall) [msgcat::mc "del all"]
    set buttons(region,newgrp) [msgcat::mc "newgrp"]
    set buttons(region,grps) [msgcat::mc "grps"]
    set buttons(region,list) [msgcat::mc "list"]
    set buttons(region,load) [msgcat::mc "load"]
    set buttons(region,save) [msgcat::mc "save"]

    set buttons(region,shape,circle) [msgcat::mc "circle"]
    set buttons(region,shape,ellipse) [msgcat::mc "ellipse"]
    set buttons(region,shape,box) [msgcat::mc "box"]
    set buttons(region,shape,polygon) [msgcat::mc "poly"]
    set buttons(region,shape,line) [msgcat::mc "line"]
    set buttons(region,shape,vector) [msgcat::mc "vector"]
    set buttons(region,shape,text) [msgcat::mc "text"]
    set buttons(region,shape,ruler) [msgcat::mc "ruler"]
    set buttons(region,shape,compass) [msgcat::mc "compass"]
    set buttons(region,shape,projection) [msgcat::mc "proj"]
    set buttons(region,shape,annulus) [msgcat::mc "annulus"]
    set buttons(region,shape,annulus,ellipse) [msgcat::mc "elliptical annulus"]
    set buttons(region,shape,annulus,box) [msgcat::mc "box annulus"]
    set buttons(region,shape,panda) [msgcat::mc "panda"]
    set buttons(region,shape,panda,ellipse) [msgcat::mc "epanda"]
    set buttons(region,shape,panda,box) [msgcat::mc "bpanda"]
    set buttons(region,shape,point,circle) [msgcat::mc "point"]

    set buttons(region,format,ds9) [msgcat::mc "ds9"]
    set buttons(region,format,ciao) [msgcat::mc "ciao"]
    set buttons(region,format,saotng) [msgcat::mc "saotng"]
    set buttons(region,format,saoimage) [msgcat::mc "saoimage"]
    set buttons(region,format,pros) [msgcat::mc "pros"]
    set buttons(region,format,xy) [msgcat::mc "xy"]

    frame $ds9(buttons).region1
    ButtonButton $ds9(buttons).region1.info $buttons(region,info) \
	MarkerInfo
    ButtonButton $ds9(buttons).region1.front $buttons(region,front) \
	MarkerFront
    ButtonButton $ds9(buttons).region1.back  $buttons(region,back) \
	MarkerBack
    ButtonButton $ds9(buttons).region1.all  $buttons(region,all) \
	MarkerSelectAll
    ButtonButton $ds9(buttons).region1.none  $buttons(region,none) \
	MarkerUnselectAll
    ButtonButton $ds9(buttons).region1.invert  $buttons(region,invert) \
	MarkerSelectInvert
    ButtonButton $ds9(buttons).region1.delete  $buttons(region,del) \
	MarkerDeleteSelect
    ButtonButton $ds9(buttons).region1.deleteall  $buttons(region,delall) \
	MarkerDeleteAllMenu
    ButtonButton $ds9(buttons).region1.newgrp  $buttons(region,newgrp) \
	GroupCreate
    ButtonButton $ds9(buttons).region1.grps  $buttons(region,grps) \
	GroupDialog
    ButtonButton $ds9(buttons).region1.list  $buttons(region,list) \
	MarkerDisplay
    ButtonButton $ds9(buttons).region1.load  $buttons(region,load) \
	MarkerOpen
    ButtonButton $ds9(buttons).region1.save  $buttons(region,save) \
	MarkerSave
    RadioButton $ds9(buttons).region1.more $buttons(more) \
	buttons(majorCurrent) $ds9(buttons).region2 MajorButton
    
    frame $ds9(buttons).region2
    RadioButton $ds9(buttons).region2.circle $buttons(region,shape,circle) \
	marker(shape) circle {}
    RadioButton $ds9(buttons).region2.ellipse $buttons(region,shape,ellipse) \
	marker(shape) ellipse {}
    RadioButton $ds9(buttons).region2.box $buttons(region,shape,box) \
	marker(shape) box {}
    RadioButton $ds9(buttons).region2.polygon $buttons(region,shape,polygon) \
	marker(shape) polygon {}
    RadioButton $ds9(buttons).region2.line $buttons(region,shape,line) \
	marker(shape) line {}
    RadioButton $ds9(buttons).region2.vector $buttons(region,shape,vector) \
	marker(shape) vector {}
    RadioButton $ds9(buttons).region2.text $buttons(region,shape,text) \
	marker(shape) text {}
    RadioButton $ds9(buttons).region2.ruler $buttons(region,shape,ruler) \
	marker(shape) ruler {}
    RadioButton $ds9(buttons).region2.compass $buttons(region,shape,compass) \
	marker(shape) compass {}
    RadioButton $ds9(buttons).region2.projection \
	$buttons(region,shape,projection) \
	marker(shape) projection {}
    RadioButton $ds9(buttons).region2.point \
	$buttons(region,shape,point,circle) \
	marker(shape) "circle point" {}
    RadioButton $ds9(buttons).region2.more $buttons(more) \
	buttons(majorCurrent) $ds9(buttons).region3 MajorButton

    frame $ds9(buttons).region3
    RadioButton $ds9(buttons).region3.annulus \
	$buttons(region,shape,annulus) \
	marker(shape) annulus {}
    RadioButton $ds9(buttons).region3.ellispsannulus \
	$buttons(region,shape,annulus,ellipse) \
	marker(shape) ellipseannulus {}
    RadioButton $ds9(buttons).region3.boxannulus \
	$buttons(region,shape,annulus,box) \
	marker(shape) boxannulus {}
    RadioButton $ds9(buttons).region3.panda \
	$buttons(region,shape,panda) \
	marker(shape) panda {}
    RadioButton $ds9(buttons).region3.epanda \
	$buttons(region,shape,panda,ellipse) \
	marker(shape) epanda {}
    RadioButton $ds9(buttons).region3.bpanda \
	$buttons(region,shape,panda,box) \
	marker(shape) bpanda {}
    RadioButton $ds9(buttons).region3.more $buttons(more) \
	buttons(majorCurrent) $ds9(buttons).region4 MajorButton

    frame $ds9(buttons).region4
    RadioButton $ds9(buttons).region4.ds9 $buttons(region,format,ds9) \
	marker(format) ds9 {}
    RadioButton $ds9(buttons).region4.ciao $buttons(region,format,ciao) \
	marker(format) ciao {}
    RadioButton $ds9(buttons).region4.saotng $buttons(region,format,saotng) \
	marker(format) saotng {}
    RadioButton $ds9(buttons).region4.saoimage \
	$buttons(region,format,saoimage) \
	marker(format) saoimage {}
    RadioButton $ds9(buttons).region4.pros $buttons(region,format,pros) \
	marker(format) pros {}
    RadioButton $ds9(buttons).region4.xy $buttons(region,format,xy) \
	marker(format) xy {}
    RadioButton $ds9(buttons).region4.more $buttons(more) \
	buttons(majorCurrent) $ds9(buttons).region5 MajorButton

    frame $ds9(buttons).region5
    RadioButton $ds9(buttons).region5.image $buttons(wcs,image) \
	marker(system) image {}
    RadioButton $ds9(buttons).region5.physical $buttons(wcs,physical) \
	marker(system) physical {}
    RadioButton $ds9(buttons).region5.wcs $buttons(wcs,wcs) \
	marker(system) wcs {}
    RadioButton $ds9(buttons).region5.fk4 $buttons(wcs,fk4) \
	marker(sky) fk4 {}
    RadioButton $ds9(buttons).region5.fk5 $buttons(wcs,fk5) \
	marker(sky) fk5 {}
    RadioButton $ds9(buttons).region5.icrs $buttons(wcs,icrs) \
	marker(sky) icrs {}
    RadioButton $ds9(buttons).region5.galactic $buttons(wcs,galactic) \
	marker(sky) galactic {}
    RadioButton $ds9(buttons).region5.ecliptic $buttons(wcs,ecliptic) \
	marker(sky) ecliptic {}
    RadioButton $ds9(buttons).region5.deg $buttons(wcs,degrees) \
	marker(skyformat) degrees {}
    RadioButton $ds9(buttons).region5.sex $buttons(wcs,sexagesimal) \
	marker(skyformat) sexagesimal {}
    RadioButton $ds9(buttons).region5.more $buttons(more) \
	buttons(majorCurrent) $ds9(buttons).region1 MajorButton
}

proc UpdateRegionMenu {} {
    global ds9
    global current
    global marker
    global menu

    if {$current(frame) != {}} {
	set marker(show) [$current(frame) get marker show]
	set marker(show,text) [$current(frame) get marker show text]
	set marker(preserve) [$current(frame) get marker preserve]

	switch -- $ds9(mode) {
	    pointer {
		if {[$current(frame) get marker select number] == 1} {
		    set marker(color) [$current(frame) get marker color]
		    set marker(edit) [$current(frame) get marker property edit]
		    set marker(move) [$current(frame) get marker property move]
		    set marker(rotate) \
			[$current(frame) get marker property rotate]
		    set marker(delete) \
			[$current(frame) get marker property delete]
		    set marker(fixed) \
			[$current(frame) get marker property fixed]
		    set marker(include) \
			[$current(frame) get marker property include]
		    set marker(source) \
			[$current(frame) get marker property source]

		    set f [$current(frame) get marker font]

		    set marker(font) [lindex $f 0]
		    set marker(font,size) [lindex $f 1]
		    set marker(font,style) [lindex $f 2]
		}
	    }
	}
    }

    UpdateMarkerFormatMenu
}

