#  Copyright (C) 1999-2005
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc ScaleMenu {} {
    global ds9
    global menu

    set menu(scale,linear) [msgcat::mc "Linear"]
    set menu(scale,log) [msgcat::mc "Log"]
    set menu(scale,pow) [msgcat::mc "Power"]
    set menu(scale,sqrt) [msgcat::mc "Square Root"]
    set menu(scale,squared) [msgcat::mc "Squared"]
    set menu(scale,histequ) [msgcat::mc "Histogram Equalization"]
    set menu(scale,mode,minmax) [msgcat::mc "MinMax"]
    set menu(scale,mode,99.5) [msgcat::mc "99.5%"]
    set menu(scale,mode,99) [msgcat::mc "99%"]
    set menu(scale,mode,98) [msgcat::mc "98%"]
    set menu(scale,mode,95) [msgcat::mc "95%"]
    set menu(scale,mode,90) [msgcat::mc "90%"]
    set menu(scale,mode,zscale) [msgcat::mc "ZScale"]
    set menu(scale,mode,zmax) [msgcat::mc "ZMax"]
    set menu(scale,mode,user) [msgcat::mc "User"]
    set menu(scale,scope) [msgcat::mc "Scope"]
    set menu(scale,minmax) [msgcat::mc "MinMax"]
    set menu(scale,datasec) [msgcat::mc "use DATASEC"]
    set menu(scale,params) [msgcat::mc "Scale Parameters..."]

    set menu(scale,scope,global) [msgcat::mc "Global"]
    set menu(scale,scope,local) [msgcat::mc "Local"]

    set menu(scale,minmax,auto) [msgcat::mc "Auto"]
    set menu(scale,minmax,scan) [msgcat::mc "Scan"]
    set menu(scale,minmax,sample) [msgcat::mc "Sample"]
    set menu(scale,minmax,data) [msgcat::mc "DATAMIN DATAMAX"]
    set menu(scale,minmax,iraf) [msgcat::mc "IRAF-MIN IRAF-MAX"]
    set menu(scale,minmax,params) [msgcat::mc "Sample Increment..."]

    set menu(scale,zscale,params) [msgcat::mc "ZScale..."]

    menu $ds9(mb).scale -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Scale"
    $ds9(mb).scale add radiobutton -label $menu(scale,linear) \
	-variable scale(type) -command ChangeScale -value linear
    $ds9(mb).scale add radiobutton -label $menu(scale,log) \
	-variable scale(type) -command ChangeScale -value log
    $ds9(mb).scale add radiobutton -label $menu(scale,pow) \
	-variable scale(type) -command ChangeScale -value pow
    $ds9(mb).scale add radiobutton -label $menu(scale,sqrt) \
	-variable scale(type) -command ChangeScale -value sqrt
    $ds9(mb).scale add radiobutton -label $menu(scale,squared) \
	-variable scale(type) -command ChangeScale -value squared
    $ds9(mb).scale add radiobutton -label $menu(scale,histequ) \
	-variable scale(type) -command ChangeScale -value histequ
    $ds9(mb).scale add separator
    $ds9(mb).scale add radiobutton -label $menu(scale,mode,minmax) \
        -variable scale(mode) -command ChangeScaleMode -value minmax
    $ds9(mb).scale add radiobutton -label $menu(scale,mode,99.5) \
	-variable scale(mode) -command ChangeScaleMode -value 99.5
    $ds9(mb).scale add radiobutton -label $menu(scale,mode,99) \
	-variable scale(mode) -command ChangeScaleMode -value 99
    $ds9(mb).scale add radiobutton -label $menu(scale,mode,98) \
	-variable scale(mode) -command ChangeScaleMode -value 98
    $ds9(mb).scale add radiobutton -label $menu(scale,mode,95) \
	-variable scale(mode) -command ChangeScaleMode -value 95
    $ds9(mb).scale add radiobutton -label $menu(scale,mode,90) \
	-variable scale(mode) -command ChangeScaleMode -value 90
    $ds9(mb).scale add radiobutton -label $menu(scale,mode,zscale) \
	-variable scale(mode) 	-command ChangeScaleMode -value zscale
    $ds9(mb).scale add radiobutton -label $menu(scale,mode,zmax) \
	-variable scale(mode) -command ChangeScaleMode -value zmax
    $ds9(mb).scale add radiobutton -label $menu(scale,mode,user) \
	-variable scale(mode) -command ChangeScaleMode -value user
    $ds9(mb).scale add separator
    $ds9(mb).scale add cascade -label $menu(scale,scope) \
	-menu $ds9(mb).scale.scope
    $ds9(mb).scale add cascade -label $menu(scale,minmax) \
	-menu $ds9(mb).scale.minmax
    $ds9(mb).scale add separator
    $ds9(mb).scale add checkbutton -label $menu(scale,datasec) \
	-variable scale(datasec) -command ChangeDATASEC
    $ds9(mb).scale add separator
    $ds9(mb).scale add command -label $menu(scale,params) \
	-command ScaleDialog

    menu $ds9(mb).scale.scope -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Scale Scope"
    $ds9(mb).scale.scope add radiobutton -label $menu(scale,scope,global) \
	-variable scale(scope) -command ChangeScaleScope -value global
    $ds9(mb).scale.scope add radiobutton -label $menu(scale,scope,local) \
	-variable scale(scope) -command ChangeScaleScope -value local

    menu $ds9(mb).scale.minmax -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Scale MinMax"
    $ds9(mb).scale.minmax add radiobutton -label $menu(scale,minmax,auto) \
	-variable minmax(mode) -value auto -command ChangeMinMaxMode
    $ds9(mb).scale.minmax add radiobutton -label $menu(scale,minmax,scan) \
	-variable minmax(mode) -value scan -command ChangeMinMaxMode
    $ds9(mb).scale.minmax add radiobutton -label $menu(scale,minmax,sample) \
	-variable minmax(mode) -value sample -command ChangeMinMaxMode
    $ds9(mb).scale.minmax add radiobutton -label $menu(scale,minmax,data) \
	-variable minmax(mode) -value datamin -command ChangeMinMaxMode
    $ds9(mb).scale.minmax add radiobutton -label $menu(scale,minmax,iraf) \
	-variable minmax(mode) -value irafmin -command ChangeMinMaxMode
    $ds9(mb).scale.minmax add separator
    $ds9(mb).scale.minmax add command -label $menu(scale,minmax,params) \
	-command {MinMaxSampleDialog minmax(sample) 1}

    ScalePrefsMenu
}

proc ScalePrefsMenu {} {
    global ds9
    global menu
    global prefs

    menu $ds9(mb).prefs.gui.scale -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.gui.scale add radiobutton -label $menu(scale,linear) \
	-variable prefs(scale) -value linear -command SavePrefs
    $ds9(mb).prefs.gui.scale add radiobutton -label $menu(scale,log) \
	-variable prefs(scale) -value log -command SavePrefs
    $ds9(mb).prefs.gui.scale add radiobutton -label $menu(scale,pow) \
	-variable prefs(scale) -value pow -command SavePrefs
    $ds9(mb).prefs.gui.scale add radiobutton -label $menu(scale,sqrt) \
	-variable prefs(scale) -value sqrt -command SavePrefs
    $ds9(mb).prefs.gui.scale add radiobutton -label $menu(scale,squared) \
	-variable prefs(scale) -value squared -command SavePrefs
    $ds9(mb).prefs.gui.scale add radiobutton -label $menu(scale,histequ) \
	-variable prefs(scale) -value histequ -command SavePrefs
    $ds9(mb).prefs.gui.scale add separator
    $ds9(mb).prefs.gui.scale add radiobutton -label  $menu(scale,mode,minmax) \
	-variable prefs(scale,mode) -value minmax -command SavePrefs
    $ds9(mb).prefs.gui.scale add radiobutton -label $menu(scale,mode,99.5) \
	-variable prefs(scale,mode) -value 99.5 -command SavePrefs
    $ds9(mb).prefs.gui.scale add radiobutton -label $menu(scale,mode,99) \
	-variable prefs(scale,mode) -value 99 -command SavePrefs
    $ds9(mb).prefs.gui.scale add radiobutton -label $menu(scale,mode,98) \
	-variable prefs(scale,mode) -value 98 -command SavePrefs
    $ds9(mb).prefs.gui.scale add radiobutton -label $menu(scale,mode,95) \
	-variable prefs(scale,mode) -value 95 -command SavePrefs
    $ds9(mb).prefs.gui.scale add radiobutton -label $menu(scale,mode,90) \
	-variable prefs(scale,mode) -value 90 -command SavePrefs
    $ds9(mb).prefs.gui.scale add radiobutton -label $menu(scale,mode,zscale) \
	-variable prefs(scale,mode) -value zscale -command SavePrefs
    $ds9(mb).prefs.gui.scale add radiobutton -label $menu(scale,mode,zmax) \
	-variable prefs(scale,mode) -value zmax -command SavePrefs
    $ds9(mb).prefs.gui.scale add radiobutton -label $menu(scale,mode,user) \
	-variable prefs(scale,mode) -value user -command SavePrefs
    $ds9(mb).prefs.gui.scale add separator
    $ds9(mb).prefs.gui.scale add cascade -label $menu(scale,scope) \
	-menu $ds9(mb).prefs.gui.scale.scope
    $ds9(mb).prefs.gui.scale add cascade -label $menu(scale,minmax) \
	-menu $ds9(mb).prefs.gui.scale.minmax
    $ds9(mb).prefs.gui.scale add separator
    $ds9(mb).prefs.gui.scale add checkbutton -label $menu(scale,datasec) \
	-variable prefs(scale,datasec) -command SavePrefs

    menu $ds9(mb).prefs.gui.scale.scope -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.gui.scale.scope add radiobutton \
	-label $menu(scale,scope,global) \
	-variable prefs(scale,scope) -value global -command SavePrefs
    $ds9(mb).prefs.gui.scale.scope add radiobutton \
	-label $menu(scale,scope,local) \
	-variable prefs(scale,scope) -value local -command SavePrefs

    menu $ds9(mb).prefs.gui.scale.minmax -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.gui.scale.minmax add radiobutton \
	-label $menu(scale,minmax,auto) \
	-variable prefs(minmax,mode) -value auto -command SavePrefs
    $ds9(mb).prefs.gui.scale.minmax add radiobutton \
	-label $menu(scale,minmax,scan) \
	-variable prefs(minmax,mode) -value scan -command SavePrefs
    $ds9(mb).prefs.gui.scale.minmax add radiobutton \
	-label $menu(scale,minmax,sample) \
	-variable prefs(minmax,mode) -value sample -command SavePrefs
    $ds9(mb).prefs.gui.scale.minmax add radiobutton \
	-label $menu(scale,minmax,data) \
	-variable prefs(minmax,mode) -value datamin -command SavePrefs
    $ds9(mb).prefs.gui.scale.minmax add radiobutton \
	-label $menu(scale,minmax,iraf) \
	-variable prefs(minmax,mode) -value irafmin -command SavePrefs
    $ds9(mb).prefs.gui.scale.minmax add separator
    $ds9(mb).prefs.gui.scale.minmax add command \
	-label $menu(scale,minmax,params) \
	-command {MinMaxSampleDialog prefs(minmax,sample) 0}
}

proc ScaleButtons {} {
    global ds9
    global buttons
    global scale

    set buttons(scale,linear) [msgcat::mc "linear"]
    set buttons(scale,log) [msgcat::mc "log"]
    set buttons(scale,pow) [msgcat::mc "pow"]
    set buttons(scale,sqrt) [msgcat::mc "sqrt"]
    set buttons(scale,squared) [msgcat::mc "squared"]
    set buttons(scale,histequ) [msgcat::mc "hist equ"]
    set buttons(scale,mode,minmax) [msgcat::mc "minmax"]
    set buttons(scale,mode,99.5) [msgcat::mc "99.5%"]
    set buttons(scale,mode,99) [msgcat::mc "99%"]
    set buttons(scale,mode,98) [msgcat::mc "98%"]
    set buttons(scale,mode,95) [msgcat::mc "95%"]
    set buttons(scale,mode,90) [msgcat::mc "90%"]
    set buttons(scale,mode,zscale) [msgcat::mc "zscale"]
    set buttons(scale,mode,zmax) [msgcat::mc "zmax"]
    set buttons(scale,mode,user) [msgcat::mc "user"]

    frame $ds9(buttons).scale
    RadioButton $ds9(buttons).scale.linear $buttons(scale,linear) \
	scale(type) linear ChangeScale
    RadioButton $ds9(buttons).scale.log $buttons(scale,log) \
	scale(type) log ChangeScale
    RadioButton $ds9(buttons).scale.pow $buttons(scale,pow) \
	scale(type) pow ChangeScale
    RadioButton $ds9(buttons).scale.sqrt $buttons(scale,sqrt) \
	scale(type) sqrt ChangeScale
    RadioButton $ds9(buttons).scale.squared $buttons(scale,squared) \
	scale(type) squared ChangeScale
    RadioButton $ds9(buttons).scale.histogram $buttons(scale,histequ) \
	scale(type) histequ ChangeScale
    RadioButton $ds9(buttons).scale.minmax $buttons(scale,mode,minmax) \
	scale(mode) minmax ChangeScaleMode
    RadioButton $ds9(buttons).scale.p995 $buttons(scale,mode,99.5) \
	scale(mode) 99.5 ChangeScaleMode
    RadioButton $ds9(buttons).scale.p99 $buttons(scale,mode,99) \
	scale(mode) 99 ChangeScaleMode
    RadioButton $ds9(buttons).scale.p98 $buttons(scale,mode,98) \
	scale(mode) 98 ChangeScaleMode
    RadioButton $ds9(buttons).scale.p95 $buttons(scale,mode,95) \
	scale(mode) 95 ChangeScaleMode
    RadioButton $ds9(buttons).scale.p90 $buttons(scale,mode,90) \
	scale(mode) 90 ChangeScaleMode
    RadioButton $ds9(buttons).scale.zscale $buttons(scale,mode,zscale) \
	scale(mode) zscale ChangeScaleMode
    RadioButton $ds9(buttons).scale.zmax $buttons(scale,mode,zmax) \
	scale(mode) zmax ChangeScaleMode
    RadioButton $ds9(buttons).scale.user $buttons(scale,mode,user) \
	scale(mode) user ChangeScaleMode
}

proc UpdateScaleMenu {} {
    global ds9
    global current
    global scale
    global menu

    global debug
    if {$debug(tcl,update)} {
	puts "UpdateScaleMenu"
    }

    if {$current(frame) != {}} {
	if {![$current(frame) has iis]} {
	    $ds9(mb) entryconfig $menu(scale) -state normal
	    $ds9(buttons).major.scale configure -state normal

	    set scale(type) [$current(frame) get colorscale]
	    set scale(scope) [$current(frame) get clip scope]
	    set scale(mode) [$current(frame) get clip mode]
	    set scale(datasec) [$current(frame) get datasec]
	    set scale(preserve) [$current(frame) get clip preserve]
	    set minmax(mode) [$current(frame) get clip minmax mode]
	    set minmax(sample) [$current(frame) get clip minmax sample]

	    if {[$current(frame) has fits]} {
		if {[$current(frame) has fits mosaic] || \
			[$current(frame) has fits cube]} {
		    $ds9(mb).scale entryconfig $menu(scale,scope) \
			-state normal
		} else {
		    $ds9(mb).scale entryconfig $menu(scale,scope) \
			-state disabled
		}

		if [$current(frame) has datasec] {
		    $ds9(mb).scale entryconfig $menu(scale,datasec) \
			-state normal
		} else {
		    $ds9(mb).scale entryconfig $menu(scale,datasec) \
			-state disabled
		}

		if [$current(frame) has datamin] {
		    $ds9(mb).scale.minmax \
			entryconfig $menu(scale,minmax,data) -state normal
		} else {
		    $ds9(mb).scale.minmax \
			entryconfig $menu(scale,minmax,data) -state disabled
		}

		if [$current(frame) has irafmin] {
		    $ds9(mb).scale.minmax \
			entryconfig $menu(scale,minmax,iraf) -state normal
		} else {
		    $ds9(mb).scale.minmax \
			entryconfig $menu(scale,minmax,iraf) -state disabled
		}
	    } else {
		$ds9(mb).scale entryconfig $menu(scale,scope) -state normal
		$ds9(mb).scale entryconfig $menu(scale,datasec) -state normal
		$ds9(mb).scale.minmax entryconfig $menu(scale,minmax,data) \
		    -state normal
		$ds9(mb).scale.minmax entryconfig $menu(scale,minmax,iraf) \
		    -state normal
	    }

	    return
	}
    }

    # default
    $ds9(mb) entryconfig $menu(scale) -state disabled
    $ds9(buttons).major.scale configure -state disabled
}

