#  Copyright (C) 1999-2005
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc ViewMenu {} {
    global ds9
    global menu

    set menu(view,layout,horz) [msgcat::mc "Horizontal Layout"]
    set menu(view,layout,vert) [msgcat::mc "Vertical Layout"]
    set menu(view,info) [msgcat::mc "Information Panel"]
    set menu(view,panner) [msgcat::mc "Panner"]
    set menu(view,magnifer) [msgcat::mc "Magnifier"]
    set menu(view,buttons) [msgcat::mc "Buttons"]
    set menu(view,colorbar) [msgcat::mc "Colorbar"]
    set menu(view,graph,horz) [msgcat::mc "Horizontal Graph"]
    set menu(view,graph,vert) [msgcat::mc "Vertical Graph"]

    set menu(view,info,filename) [msgcat::mc "Filename"]
    set menu(view,info,object) [msgcat::mc "Object"]
    set menu(view,info,minmax) [msgcat::mc "Min Max"]
    set menu(view,lowhigh) [msgcat::mc "Low High"]
    set menu(view,info,frame) [msgcat::mc "Frame Info"]

    menu $ds9(mb).view -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).view add radiobutton -label $menu(view,layout,horz) \
	-variable view(layout) -value horizontal  \
	-command {LayoutViewReset; UpdateView}
    $ds9(mb).view add radiobutton -label $menu(view,layout,vert) \
	-variable view(layout) -value vertical  \
	-command {LayoutViewReset; UpdateView}
    $ds9(mb).view add separator
    $ds9(mb).view add checkbutton -label $menu(view,info) \
	-variable view(info) -command UpdateView
    $ds9(mb).view add checkbutton -label $menu(view,panner) \
	-variable view(panner) -command UpdateView
    $ds9(mb).view add checkbutton -label $menu(view,magnifer) \
	-variable view(magnifier) -command UpdateView
    $ds9(mb).view add checkbutton -label $menu(view,buttons) \
	-variable view(buttons) -command UpdateView
    $ds9(mb).view add checkbutton -label $menu(view,colorbar) \
	-variable view(colorbar) -command UpdateView
    $ds9(mb).view add checkbutton -label $menu(view,graph,horz) \
	-variable view(graph,horz) -command UpdateView
    $ds9(mb).view add checkbutton -label $menu(view,graph,vert) \
	-variable view(graph,vert) -command UpdateView
    $ds9(mb).view add separator
    $ds9(mb).view add checkbutton -label $menu(view,info,filename) \
	-variable view(info,filename) -command UpdateView
    $ds9(mb).view add checkbutton -label $menu(view,info,object) \
	-variable view(info,object) -command UpdateView
    $ds9(mb).view add checkbutton -label $menu(view,info,minmax) \
	-variable view(info,minmax) -command UpdateView
    $ds9(mb).view add checkbutton -label $menu(view,lowhigh) \
	-variable view(info,lowhigh) -command UpdateView
    $ds9(mb).view add checkbutton -label $menu(view,info,frame) \
	-variable view(info,frame) -command UpdateView
    $ds9(mb).view add checkbutton -label $menu(wcs) \
	-variable view(info,wcs) -command UpdateView
    $ds9(mb).view add cascade -label $menu(wcs,multi) \
	-menu $ds9(mb).view.wcs -command UpdateView
    $ds9(mb).view add checkbutton -label $menu(wcs,image) \
	-variable view(info,image) -command UpdateView
    $ds9(mb).view add checkbutton -label $menu(wcs,physical) \
	-variable view(info,physical) -command UpdateView
    $ds9(mb).view add checkbutton -label $menu(wcs,amplifier) \
	-variable view(info,amplifier) -command UpdateView
    $ds9(mb).view add checkbutton -label $menu(wcs,detector) \
	-variable view(info,detector) -command UpdateView

    # View Info Panel WCS Prefs
    menu $ds9(mb).view.wcs -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	$ds9(mb).view.wcs add checkbutton \
	    -label "$menu(wcs) $l" \
	    -variable "view(info,wcs$l)" \
	    -command UpdateView
    }

    ViewPrefsMenu
}

proc ViewPrefsMenu {} {
    global ds9
    global menu
    global prefs

    menu $ds9(mb).prefs.gui.view -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.gui.view add radiobutton -label $menu(view,layout,horz) \
	-variable prefs(view,layout) -value horizontal -command SavePrefs
    $ds9(mb).prefs.gui.view add radiobutton -label $menu(view,layout,vert) \
	-variable prefs(view,layout) -value vertical -command SavePrefs
    $ds9(mb).prefs.gui.view add separator
    $ds9(mb).prefs.gui.view add checkbutton -label $menu(view,info) \
	-variable prefs(view,info) -command SavePrefs
    $ds9(mb).prefs.gui.view add checkbutton -label $menu(view,panner) \
	-variable prefs(view,panner) -command SavePrefs
    $ds9(mb).prefs.gui.view add checkbutton -label $menu(view,magnifer) \
	-variable prefs(view,magnifier) -command SavePrefs
    $ds9(mb).prefs.gui.view add checkbutton -label $menu(view,buttons) \
	-variable prefs(view,buttons) -command SavePrefs
    $ds9(mb).prefs.gui.view add checkbutton -label $menu(view,colorbar) \
	-variable prefs(view,colorbar) -command SavePrefs
    $ds9(mb).prefs.gui.view add checkbutton -label $menu(view,graph,horz) \
	-variable prefs(view,graph,horz) -command SavePrefs
    $ds9(mb).prefs.gui.view add checkbutton -label $menu(view,graph,vert) \
	-variable prefs(view,graph,vert) -command SavePrefs
    $ds9(mb).prefs.gui.view add separator
    $ds9(mb).prefs.gui.view add checkbutton -label $menu(view,info,filename) \
	-variable prefs(view,info,filename) -command SavePrefs
    $ds9(mb).prefs.gui.view add checkbutton -label $menu(view,info,object) \
	-variable prefs(view,info,object) -command SavePrefs
    $ds9(mb).prefs.gui.view add checkbutton -label $menu(view,info,minmax) \
	-variable prefs(view,info,minmax) -command SavePrefs
    $ds9(mb).prefs.gui.view add checkbutton -label $menu(view,lowhigh) \
	-variable prefs(view,info,lowhigh) -command SavePrefs
    $ds9(mb).prefs.gui.view add checkbutton -label $menu(view,info,frame) \
	-variable prefs(view,info,frame) -command SavePrefs
    $ds9(mb).prefs.gui.view add checkbutton -label $menu(wcs) \
	-variable prefs(view,info,wcs) -command SavePrefs
    $ds9(mb).prefs.gui.view add cascade -label $menu(wcs,multi) \
	-menu $ds9(mb).prefs.gui.view.wcs
    $ds9(mb).prefs.gui.view add checkbutton -label $menu(wcs,image) \
	-variable prefs(view,info,image) -command SavePrefs
    $ds9(mb).prefs.gui.view add checkbutton -label $menu(wcs,physical) \
	-variable prefs(view,info,physical) -command SavePrefs
    $ds9(mb).prefs.gui.view add checkbutton -label $menu(wcs,amplifier) \
	-variable prefs(view,info,amplifier) -command SavePrefs
    $ds9(mb).prefs.gui.view add checkbutton -label $menu(wcs,detector) \
	-variable prefs(view,info,detector) -command SavePrefs

    # View WCS Prefs
    menu $ds9(mb).prefs.gui.view.wcs -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	$ds9(mb).prefs.gui.view.wcs add checkbutton \
	    -label "$menu(wcs) $l" \
	    -variable "prefs(view,info,wcs$l)" -command SavePrefs
    }
}

proc ViewButtons {} {
    global ds9
    global buttons
    global view

    set buttons(view,info) [msgcat::mc "info panel"]
    set buttons(view,panner) [msgcat::mc "panner"]
    set buttons(view,magnifer) [msgcat::mc "magnifier"]
    set buttons(view,buttons) [msgcat::mc "buttons"]
    set buttons(view,colorbar) [msgcat::mc "colorbar"]
    set buttons(view,graph,horz) [msgcat::mc "hor graph"]
    set buttons(view,graph,vert) [msgcat::mc "vert graph"]

    frame $ds9(buttons).view
    CheckButton $ds9(buttons).view.info $buttons(view,info) \
	view(info) UpdateView
    CheckButton $ds9(buttons).view.panner $buttons(view,panner) \
	view(panner) UpdateView
    CheckButton $ds9(buttons).view.magnifier $buttons(view,magnifer) \
	view(magnifier) UpdateView
    CheckButton $ds9(buttons).view.buttons $buttons(view,buttons) \
	view(buttons) UpdateView
    CheckButton $ds9(buttons).view.colorbar $buttons(view,colorbar) \
	view(colorbar) UpdateView
    CheckButton $ds9(buttons).view.graphhorz $buttons(view,graph,horz) \
	view(graph,horz) UpdateView
    CheckButton $ds9(buttons).view.graphvert $buttons(view,graph,vert) \
	view(graph,vert) UpdateView
}

