#  Copyright (C) 1999-2005
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc PrefsMenu {} {
    global ds9
    global menu
    global prefs

    menu $ds9(mb).prefs -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Preferences"
    $ds9(mb).prefs add cascade -label "Menus" -menu $ds9(mb).prefs.gui
#    $ds9(mb).prefs add cascade -label "Language" -menu $ds9(mb).prefs.lang
    $ds9(mb).prefs add cascade -label "Mask Color" \
	-menu $ds9(mb).prefs.mask
    $ds9(mb).prefs add cascade -label "Background Color" \
	-menu $ds9(mb).prefs.bg
    $ds9(mb).prefs add cascade -label "Blank/Inf/NaN Color" \
	-menu $ds9(mb).prefs.nan
    $ds9(mb).prefs add cascade -label "Horizontal Graph" \
	-menu $ds9(mb).prefs.horz
    $ds9(mb).prefs add cascade -label "Vertical Graph" \
	-menu $ds9(mb).prefs.vert
    $ds9(mb).prefs add cascade -label "Default Menu Font" \
	-menu $ds9(mb).prefs.font
    $ds9(mb).prefs add cascade -label "Panner" \
	-menu $ds9(mb).prefs.panner
    $ds9(mb).prefs add cascade -label "Magnifier" \
	-menu $ds9(mb).prefs.magnifier
    $ds9(mb).prefs add cascade -label "Truecolor Colorbar" \
	-menu $ds9(mb).prefs.colorbar
    $ds9(mb).prefs add cascade -label "Dialog Box" \
	-menu $ds9(mb).prefs.dialog
    $ds9(mb).prefs add cascade -label "Pan" \
	-menu $ds9(mb).prefs.pan
    $ds9(mb).prefs add cascade -label "Print Coordinates" \
	-menu $ds9(mb).prefs.coord
    $ds9(mb).prefs add cascade -label "Examine" \
	-menu $ds9(mb).prefs.examine
    $ds9(mb).prefs add cascade -label "Misc" \
	-menu $ds9(mb).prefs.misc
    $ds9(mb).prefs add command -label "HTTP..." -command PrefsHTTP
    $ds9(mb).prefs add separator
    $ds9(mb).prefs add command -label "Clear Preferences" \
	-command ClearPrefsMenu

    # Menus
    menu $ds9(mb).prefs.gui -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor) -title "DS9 Preferences"
    $ds9(mb).prefs.gui add cascade -label $menu(file) \
	-menu $ds9(mb).prefs.gui.file
    $ds9(mb).prefs.gui add cascade -label $menu(edit) \
	-menu $ds9(mb).prefs.gui.edit
    $ds9(mb).prefs.gui add cascade -label $menu(view) \
	-menu $ds9(mb).prefs.gui.view
    $ds9(mb).prefs.gui add cascade -label $menu(frame) \
	-menu $ds9(mb).prefs.gui.frame
    $ds9(mb).prefs.gui add cascade -label $menu(bin) \
	-menu $ds9(mb).prefs.gui.bin
    $ds9(mb).prefs.gui add cascade -label $menu(zoom) \
	-menu $ds9(mb).prefs.gui.zoom
    $ds9(mb).prefs.gui add cascade -label $menu(scale) \
	-menu $ds9(mb).prefs.gui.scale
    $ds9(mb).prefs.gui add cascade -label $menu(color) \
	-menu $ds9(mb).prefs.gui.color
    $ds9(mb).prefs.gui add cascade -label $menu(region) \
	-menu $ds9(mb).prefs.gui.region
    $ds9(mb).prefs.gui add cascade -label $menu(wcs) \
	-menu $ds9(mb).prefs.gui.wcs
    $ds9(mb).prefs.gui add cascade -label $menu(analysis) \
	-menu $ds9(mb).prefs.gui.analysis

    # Language
    menu $ds9(mb).prefs.lang -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.lang add radiobutton -label "Locale" \
	-variable ds9(language) -value locale -command SaveNextPrefs
    $ds9(mb).prefs.lang add separator
    $ds9(mb).prefs.lang add radiobutton -label "English" \
	-variable ds9(language) -value en -command SaveNextPrefs
    $ds9(mb).prefs.lang add radiobutton -label "Français" \
	-variable ds9(language) -value fr -command SaveNextPrefs

    # Mask Prefs
    menu $ds9(mb).prefs.mask -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.mask add radiobutton -label $menu(color,black) \
	-variable ds9(mask,color) -value black -command PrefsMaskColor
    $ds9(mb).prefs.mask add radiobutton -label $menu(color,white) \
	-variable ds9(mask,color) -value white -command PrefsMaskColor
    $ds9(mb).prefs.mask add radiobutton -label $menu(color,red) \
	-variable ds9(mask,color) -value red -command PrefsMaskColor
    $ds9(mb).prefs.mask add radiobutton -label $menu(color,green) \
	-variable ds9(mask,color) -value green -command PrefsMaskColor
    $ds9(mb).prefs.mask add radiobutton -label $menu(color,blue) \
	-variable ds9(mask,color) -value blue -command PrefsMaskColor
    $ds9(mb).prefs.mask add radiobutton -label $menu(color,cyan) \
	-variable ds9(mask,color) -value cyan -command PrefsMaskColor
    $ds9(mb).prefs.mask add radiobutton -label $menu(color,magenta) \
	-variable ds9(mask,color) -value magenta -command PrefsMaskColor
    $ds9(mb).prefs.mask add radiobutton -label $menu(color,yellow) \
	-variable ds9(mask,color) -value yellow -command PrefsMaskColor

    # Background Color Prefs
    menu $ds9(mb).prefs.bg -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.bg add radiobutton -label $menu(color,black) \
	-variable ds9(bg,color) -value black -command PrefsBkgrColor
    $ds9(mb).prefs.bg add radiobutton -label $menu(color,white) \
	-variable ds9(bg,color) -value white -command PrefsBkgrColor
    $ds9(mb).prefs.bg add radiobutton -label $menu(color,red) \
	-variable ds9(bg,color) -value red -command PrefsBkgrColor
    $ds9(mb).prefs.bg add radiobutton -label $menu(color,green) \
	-variable ds9(bg,color) -value green -command PrefsBkgrColor
    $ds9(mb).prefs.bg add radiobutton -label $menu(color,blue) \
	-variable ds9(bg,color) -value blue -command PrefsBkgrColor
    $ds9(mb).prefs.bg add radiobutton -label $menu(color,cyan) \
	-variable ds9(bg,color) -value cyan -command PrefsBkgrColor
    $ds9(mb).prefs.bg add radiobutton -label $menu(color,magenta) \
	-variable ds9(bg,color) -value magenta -command PrefsBkgrColor
    $ds9(mb).prefs.bg add radiobutton -label $menu(color,yellow) \
	-variable ds9(bg,color) -value yellow -command PrefsBkgrColor

    # Blank/NaN Color Prefs
    menu $ds9(mb).prefs.nan -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.nan add radiobutton -label $menu(color,black) \
	-variable ds9(nan,color) -value black -command PrefsNaNColor
    $ds9(mb).prefs.nan add radiobutton -label $menu(color,white) \
	-variable ds9(nan,color) -value white -command PrefsNaNColor
    $ds9(mb).prefs.nan add radiobutton -label $menu(color,red) \
	-variable ds9(nan,color) -value red -command PrefsNaNColor
    $ds9(mb).prefs.nan add radiobutton -label $menu(color,green) \
	-variable ds9(nan,color) -value green -command PrefsNaNColor
    $ds9(mb).prefs.nan add radiobutton -label $menu(color,blue) \
	-variable ds9(nan,color) -value blue -command PrefsNaNColor
    $ds9(mb).prefs.nan add radiobutton -label $menu(color,cyan) \
	-variable ds9(nan,color) -value cyan -command PrefsNaNColor
    $ds9(mb).prefs.nan add radiobutton -label $menu(color,magenta) \
	-variable ds9(nan,color) -value magenta -command PrefsNaNColor
    $ds9(mb).prefs.nan add radiobutton -label $menu(color,yellow) \
	-variable ds9(nan,color) -value yellow -command PrefsNaNColor

    # Horizontal Graph Prefs
    menu $ds9(mb).prefs.horz -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.horz add checkbutton -label "Grid" \
	-variable graph(horz,grid) -command PrefsGraphGrid
    $ds9(mb).prefs.horz add separator
    $ds9(mb).prefs.horz add radiobutton -label "Linear" \
	-variable graph(horz,log) -value false -command PrefsGraphYAxis
    $ds9(mb).prefs.horz add radiobutton -label "Log" \
	-variable graph(horz,log) -value true -command PrefsGraphYAxis

    # Vertical Graph Prefs
    menu $ds9(mb).prefs.vert -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.vert add checkbutton -label "Grid" \
	-variable graph(vert,grid) -command  PrefsGraphGrid
    $ds9(mb).prefs.vert add separator
    $ds9(mb).prefs.vert add radiobutton -label "Linear" \
	-variable graph(vert,log) -value false -command PrefsGraphYAxis
    $ds9(mb).prefs.vert add radiobutton -label "Log" \
	-variable graph(vert,log) -value true -command PrefsGraphYAxis

    # Font Prefs
    menu $ds9(mb).prefs.font -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.font add radiobutton -label "Default" \
	-variable ds9(font) -value default -command SaveNextPrefs
    $ds9(mb).prefs.font add separator
    $ds9(mb).prefs.font add radiobutton -label "Times" \
	-variable ds9(font) -value times -command SaveNextPrefs
    $ds9(mb).prefs.font add radiobutton -label "Helvetica" \
	-variable ds9(font) -value helvetica -command SaveNextPrefs
    $ds9(mb).prefs.font add radiobutton -label "Symbol" \
	-variable ds9(font) -value symbol -command SaveNextPrefs
    $ds9(mb).prefs.font add radiobutton -label "Courier" \
	-variable ds9(font) -value courier -command SaveNextPrefs
    $ds9(mb).prefs.font add separator
    $ds9(mb).prefs.font add radiobutton -label "8" \
	-variable ds9(font,size) -value 8 -command SaveNextPrefs
    $ds9(mb).prefs.font add radiobutton -label "9" \
	-variable ds9(font,size) -value 9 -command SaveNextPrefs
    $ds9(mb).prefs.font add radiobutton -label "10" \
	-variable ds9(font,size) -value 10 -command SaveNextPrefs
    $ds9(mb).prefs.font add radiobutton -label "12" \
	-variable ds9(font,size) -value 12 -command SaveNextPrefs
    $ds9(mb).prefs.font add radiobutton -label "14" \
	-variable ds9(font,size) -value 14 -command SaveNextPrefs
    $ds9(mb).prefs.font add radiobutton -label "18" \
	-variable ds9(font,size) -value 18 -command SaveNextPrefs
    $ds9(mb).prefs.font add radiobutton -label "24" \
	-variable ds9(font,size) -value 24 -command SaveNextPrefs
    $ds9(mb).prefs.font add separator
    $ds9(mb).prefs.font add radiobutton -label "Plain" \
	-variable ds9(font,style) -value normal -command SaveNextPrefs
    $ds9(mb).prefs.font add radiobutton -label "Bold" \
	-variable ds9(font,style) -value bold -command SaveNextPrefs
    $ds9(mb).prefs.font add radiobutton -label "Italic" \
	-variable ds9(font,style) -value italic -command SaveNextPrefs

    # Panner Prefs
    menu $ds9(mb).prefs.panner -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.panner add checkbutton -label "Orientation Compass" \
	-variable panner(compass,image) -command PrefsImageCompass
    $ds9(mb).prefs.panner add checkbutton -label "WCS Compass" \
	-variable panner(compass,wcs) -command PrefsWCSCompass
    $ds9(mb).prefs.panner add cascade -label "WCS Compass Coord System" \
	-menu $ds9(mb).prefs.panner.compass

    menu $ds9(mb).prefs.panner.compass -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.panner.compass add radiobutton -label $menu(wcs) \
	-variable panner(compass,wcs,system) -value wcs \
	-command PrefsWCSCompass
    $ds9(mb).prefs.panner.compass add cascade -label $menu(wcs,multi) \
	-menu $ds9(mb).prefs.panner.compass.wcs
    $ds9(mb).prefs.panner.compass add separator
    $ds9(mb).prefs.panner.compass add radiobutton -label $menu(wcs,fk4) \
	-variable panner(compass,wcs,sky) -value fk4 -command PrefsWCSCompass
    $ds9(mb).prefs.panner.compass add radiobutton -label $menu(wcs,fk5) \
	-variable panner(compass,wcs,sky) -value fk5 -command PrefsWCSCompass
    $ds9(mb).prefs.panner.compass add radiobutton -label $menu(wcs,icrs) \
	-variable panner(compass,wcs,sky) -value icrs -command PrefsWCSCompass
    $ds9(mb).prefs.panner.compass add radiobutton -label $menu(wcs,galactic) \
	-variable panner(compass,wcs,sky) -value galactic \
	-command PrefsWCSCompass
    $ds9(mb).prefs.panner.compass add radiobutton -label $menu(wcs,ecliptic) \
	-variable panner(compass,wcs,sky) -value ecliptic \
	-command PrefsWCSCompass

    menu $ds9(mb).prefs.panner.compass.wcs -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	$ds9(mb).prefs.panner.compass.wcs add radiobutton \
	    -label "$menu(wcs) $l" \
	    -variable panner(compass,wcs,system) -value "wcs$l" \
	    -command PrefsWCSCompass
    }

    # Magnifier Prefs
    menu $ds9(mb).prefs.magnifier -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.magnifier add checkbutton -label "Graphics" \
	-variable magnifier(region) -command PrefsMagnifierRegion
    $ds9(mb).prefs.magnifier add checkbutton -label "Cursor" \
	-variable magnifier(cursor) -command PrefsMagnifierCursor
    $ds9(mb).prefs.magnifier add separator
    $ds9(mb).prefs.magnifier add radiobutton -label "2x" \
	-variable magnifier(zoom) -value 2 -command PrefsMagnifierZoom
    $ds9(mb).prefs.magnifier add radiobutton -label "4x" \
	-variable magnifier(zoom) -value 4 -command PrefsMagnifierZoom
    $ds9(mb).prefs.magnifier add radiobutton -label "8x" \
	-variable magnifier(zoom) -value 8 -command PrefsMagnifierZoom
    $ds9(mb).prefs.magnifier add radiobutton -label "16x" \
	-variable magnifier(zoom) -value 16 -command PrefsMagnifierZoom
    $ds9(mb).prefs.magnifier add radiobutton -label "32x" \
	-variable magnifier(zoom) -value 32 -command PrefsMagnifierZoom

    # Colorbar Prefs
    menu $ds9(mb).prefs.colorbar -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.colorbar add radiobutton -label "Update Full Screen" \
	-variable colorbar(area) -value 0 -command PrefsColorbarArea
    $ds9(mb).prefs.colorbar add separator
    $ds9(mb).prefs.colorbar add radiobutton -label "128x128" \
	-variable colorbar(area) -value 128 -command PrefsColorbarArea
    $ds9(mb).prefs.colorbar add radiobutton -label "256x256" \
	-variable colorbar(area) -value 256 -command PrefsColorbarArea
    $ds9(mb).prefs.colorbar add radiobutton -label "512x512" \
	-variable colorbar(area) -value 512 -command PrefsColorbarArea
    $ds9(mb).prefs.colorbar add separator
    $ds9(mb).prefs.colorbar add radiobutton -label "About Center" \
	-variable colorbar(mode) -value center -command PrefsColorbarArea
    $ds9(mb).prefs.colorbar add radiobutton -label "About Mouse Click" \
	-variable colorbar(mode) -value click -command PrefsColorbarArea

    # Dialog Prefs
    menu $ds9(mb).prefs.dialog -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.dialog add radiobutton -label "Motif" \
	-variable ds9(dialog) -value motif -command SavePrefs
    $ds9(mb).prefs.dialog add radiobutton -label "Windows" \
	-variable ds9(dialog) -value windows -command SavePrefs

    global tcl_platform
    switch $tcl_platform(platform) {
	unix {}
	windows -
	macosx {
	    $ds9(mb).prefs.dialog add radiobutton -label "Native Dialog" \
		-variable ds9(dialog) -value native -command SavePrefs
	}
    }

    # Pan Prefs
    menu $ds9(mb).prefs.pan -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.pan add radiobutton -label "Click to Center" \
	-variable panzoom(mode) -value click -command SavePrefs
    $ds9(mb).prefs.pan add radiobutton -label "Drag to Center" \
	-variable panzoom(mode) -value drag -command SavePrefs
    $ds9(mb).prefs.pan add radiobutton -label "Pan then Zoom" \
	-variable panzoom(mode) -value panzoom -command SavePrefs

    # Display Coords Prefs
    menu $ds9(mb).prefs.coord -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.coord add checkbutton -label "Value" \
	-variable coord(value) -command SavePrefs
    $ds9(mb).prefs.coord add separator
    $ds9(mb).prefs.coord add checkbutton -label $menu(wcs) \
	-variable coord(wcs) -command SavePrefs
    $ds9(mb).prefs.coord add cascade -label $menu(wcs,multi) \
	-menu $ds9(mb).prefs.coord.wcs
    $ds9(mb).prefs.coord add separator
    $ds9(mb).prefs.coord add checkbutton -label $menu(wcs,image) \
	-variable coord(image) -command SavePrefs
    $ds9(mb).prefs.coord add checkbutton -label $menu(wcs,physical) \
	-variable coord(physical) -command SavePrefs
    $ds9(mb).prefs.coord add checkbutton -label $menu(wcs,amplifier) \
	-variable coord(amplifier) -command SavePrefs
    $ds9(mb).prefs.coord add checkbutton -label $menu(wcs,detector) \
	-variable coord(detector) -command SavePrefs
    $ds9(mb).prefs.coord add separator
    $ds9(mb).prefs.coord add radiobutton -label $menu(wcs,fk4) \
	-variable coord(sky) -value fk4 -command SavePrefs
    $ds9(mb).prefs.coord add radiobutton -label $menu(wcs,fk5) \
	-variable coord(sky) -value fk5 -command SavePrefs
    $ds9(mb).prefs.coord add radiobutton -label $menu(wcs,icrs) \
	-variable coord(sky) -value icrs -command SavePrefs
    $ds9(mb).prefs.coord add radiobutton -label $menu(wcs,galactic) \
	-variable coord(sky) -value galactic -command SavePrefs
    $ds9(mb).prefs.coord add radiobutton -label $menu(wcs,ecliptic) \
	-variable coord(sky) -value ecliptic -command SavePrefs
    $ds9(mb).prefs.coord add separator
    $ds9(mb).prefs.coord add radiobutton -label $menu(wcs,degrees) \
	-variable coord(skyformat) -value degrees -command SavePrefs
    $ds9(mb).prefs.coord add radiobutton -label $menu(wcs,sexagesimal) \
	-variable coord(skyformat) -value sexagesimal -command SavePrefs

    menu $ds9(mb).prefs.coord.wcs -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	$ds9(mb).prefs.coord.wcs add checkbutton -label "$menu(wcs) $l" \
	    -variable "coord(wcs$l)" -command SavePrefs
    }

    # Examine Prefs
    menu $ds9(mb).prefs.examine -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.examine add radiobutton -label "New Frame each Time" \
	-variable examine(mode) -value new -command SavePrefs
    $ds9(mb).prefs.examine add radiobutton -label "Examine Frame" \
	-variable examine(mode) -value one -command SavePrefs
    $ds9(mb).prefs.examine add separator
    $ds9(mb).prefs.examine add radiobutton -label "1x" \
	-variable examine(zoom) -value 1 -command SavePrefs
    $ds9(mb).prefs.examine add radiobutton -label "2x" \
	-variable examine(zoom) -value 2 -command SavePrefs
    $ds9(mb).prefs.examine add radiobutton -label "4x" \
	-variable examine(zoom) -value 4 -command SavePrefs
    $ds9(mb).prefs.examine add radiobutton -label "8x" \
	-variable examine(zoom) -value 8 -command SavePrefs
    $ds9(mb).prefs.examine add radiobutton -label "16x" \
	-variable examine(zoom) -value 16 -command SavePrefs

    # Misc Prefs
    menu $ds9(mb).prefs.misc -tearoff $menu(tearoff) \
	-selectcolor $menu(selectcolor)
    $ds9(mb).prefs.misc add command -label "Temporary File Directory..." \
	-command PrefsTmpDir
    $ds9(mb).prefs.misc add separator
    $ds9(mb).prefs.misc add checkbutton -label "Fast Mosaic Render" \
	-variable ds9(mosaic,fast) -command PrefsMosaicFast
    $ds9(mb).prefs.misc add checkbutton -label "Autoload FITS Regions" \
	-variable ds9(automarker) -command SavePrefs
    $ds9(mb).prefs.misc add checkbutton -label "Initialize XPA" \
	-variable ds9(xpa) -command SaveNextPrefs
}

proc ClearPrefsMenu {} {
    if {[tk_messageBox -type okcancel -default cancel \
	     -message "Clear Preferences?"] == "ok"} {
	ClearPrefs
    }
}

proc LoadPrefs {} {
    global prefs
    global ds9

    SourceInitFile {.prf}

    # now fix any backward compatibility issues
    # view
    global view
    global info
    if [info exists info(view)] {
	set view(info) $info(view)
    }
    global panner
    if [info exists panner(view)] {
	set view(panner) $panner(view)
    }
    global magnifier
    if [info exists magnifier(view)] {
	set view(magnifier) $magnifier(view)
    }
    global buttons
    if [info exists buttons(view)] {
	set view(buttons) $buttons(view)
    }
    global colorbar
    if [info exists colorbar(view)] {
	set view(colorbar) $colorbar(view)
    }
    if [info exists info(filename)] {
	set view(info,filename) $info(filename)
    }
    if [info exists info(object)] {
	set view(info,object) $info(object)
    }
    if [info exists info(minmax)] {
	set view(info,minmax) $info(minmax)
	set view(info,lowhigh) $info(minmax)
    }
    if [info exists info(wcs)] {
	set view(info,wcs) $info(wcs)
    }
    foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	if [info exists info(wcs$l)] {
	    set view(info,wcs$l) $info(wcs$l)
	}
    }
    if [info exists info(detector)] {
	set view(info,detector) $info(detector)
    }
    if [info exists info(amplifier)] {
	set view(info,amplifier) $info(amplifier)
    }
    if [info exists info(physical)] {
	set view(info,physical) $info(physical)
    }
    if [info exists info(image)] {
	set view(info,image) $info(image)
    }
    if [info exists info(frame)] {
	set view(info,frame) $info(frame)
    }
}

proc CheckPrefs {} {
    global ds9
    global prefs

    if {$prefs(version) != $ds9(version)} {
	set r [tk_messageBox -message "DS9 has detected an older preferences file, do you wish to update?" -type yesno -icon question]
	if {$r == "yes"} {
	    SavePrefs
	}
    }
}

proc ClearPrefs {} {
    DeleteInitFile {.prf}
    Info "Preferences have been reset to the default values. Please restart DS9 for these changes to take affect."
}

proc SaveNextPrefs {} {
    SavePrefs
    Info "Please restart DS9 for this preference change to take affect."
}

proc SavePrefs {} {
    global ds9
    global prefs
    global env
    global tcl_platform

    # make sure old prefs files are removed
    DeleteInitFile {.prf}

    # open prefs file
    set file [open [file join [GetEnvHome] ".$ds9(app).prf"] w]
    if {$file == {}} {
	Error "An Error as occurred while saving preferences."
	return
    }

    puts $file "global ds9"
    puts $file "global prefs"
    puts $file "set prefs(version) $ds9(version)"

    # File prefs
    puts $file ""
    puts $file "\# File prefs"
    global ps
    puts $file "global ps"
    puts $file "set prefs(ps,dest) $prefs(ps,dest)"
    puts $file "set ps(dest) $prefs(ps,dest)"
    puts $file "set prefs(ps,cmd) \{$prefs(ps,cmd)\}"
    puts $file "set ps(cmd) \{$prefs(ps,cmd)\}"
    puts $file "set prefs(ps,filename) \{$prefs(ps,filename)\}"
    puts $file "set ps(filename) \{$prefs(ps,filename)\}"
    puts $file "set prefs(ps,color) $prefs(ps,color)"
    puts $file "set ps(color) $prefs(ps,color)"
    puts $file "set prefs(ps,level) $prefs(ps,level)"
    puts $file "set ps(level) $prefs(ps,level)"
    puts $file "set prefs(ps,resolution) $prefs(ps,resolution)"
    puts $file "set ps(resolution) $prefs(ps,resolution)"

    puts $file "set prefs(ps,orient) $prefs(ps,orient)"
    puts $file "set ps(orient) $prefs(ps,orient)"
    puts $file "set prefs(ps,scale) $prefs(ps,scale)"
    puts $file "set ps(scale) $prefs(ps,scale)"
    puts $file "set prefs(ps,size) $prefs(ps,size)"
    puts $file "set ps(size) $prefs(ps,size)"
    puts $file "set prefs(ps,width) $prefs(ps,width)"
    puts $file "set ps(width) $prefs(ps,width)"
    puts $file "set prefs(ps,height) $prefs(ps,height)"
    puts $file "set ps(height) $prefs(ps,height)"

    # Edit prefs
    puts $file ""
    puts $file "\# Edit prefs"
    puts $file "set prefs(ds9,mode) $prefs(ds9,mode)"
    puts $file "set ds9(mode) $prefs(ds9,mode)"

    # View prefs
    puts $file ""
    puts $file "\# View prefs"
    global view
    puts $file "global view"
    puts $file "set prefs(view,layout) $prefs(view,layout)"
    puts $file "set view(layout) $prefs(view,layout)"
    puts $file "set prefs(view,info) $prefs(view,info)"
    puts $file "set view(info) $prefs(view,info)"
    puts $file "set prefs(view,panner) $prefs(view,panner)"
    puts $file "set view(view) $prefs(view,panner)"
    puts $file "set prefs(view,magnifier) $prefs(view,magnifier)"
    puts $file "set view(magnifier) $prefs(view,magnifier)"
    puts $file "set prefs(view,buttons) $prefs(view,buttons)"
    puts $file "set view(buttons) $prefs(view,buttons)"
    puts $file "set prefs(view,colorbar) $prefs(view,colorbar)"
    puts $file "set view(colorbar) $prefs(view,colorbar)"
    puts $file "set prefs(view,graph,horz) $prefs(view,graph,horz)"
    puts $file "set view(graph,horz) $prefs(view,graph,horz)"
    puts $file "set prefs(view,graph,vert) $prefs(view,graph,vert)"
    puts $file "set view(graph,vert) $prefs(view,graph,vert)"

    puts $file "set prefs(view,info,filename) $prefs(view,info,filename)"
    puts $file "set view(info,filename) $prefs(view,info,filename)"
    puts $file "set prefs(view,info,object) $prefs(view,info,object)"
    puts $file "set view(info,object) $prefs(view,info,object)"
    puts $file "set prefs(view,info,minmax) $prefs(view,info,minmax)"
    puts $file "set view(info,minmax) $prefs(view,info,minmax)"
    puts $file "set prefs(view,info,lowhigh) $prefs(view,info,lowhigh)"
    puts $file "set view(info,lowhigh) $prefs(view,info,lowhigh)"
    foreach l {{} a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	puts $file "set prefs(view,info,wcs$l) $prefs(view,info,wcs$l)"
	puts $file "set view(info,wcs$l) $prefs(view,info,wcs$l)"
    }
    puts $file "set prefs(view,info,detector) $prefs(view,info,detector)"
    puts $file "set view(info,detector) $prefs(view,info,detector)"
    puts $file "set prefs(view,info,amplifier) $prefs(view,info,amplifier)"
    puts $file "set view(info,amplifier) $prefs(view,info,amplifier)"
    puts $file "set prefs(view,info,physical) $prefs(view,info,physical)"
    puts $file "set view(info,physical) $prefs(view,info,physical)"
    puts $file "set prefs(view,info,image) $prefs(view,info,image)"
    puts $file "set view(info,image) $prefs(view,info,image)"
    puts $file "set prefs(view,info,frame) $prefs(view,info,frame)"
    puts $file "set view(info,frame) $prefs(view,info,frame)"

    # Frame prefs
    puts $file ""
    puts $file "\# Frame prefs"
    global tile
    puts $file "global tile"
    puts $file "set prefs(tile,mode) $prefs(tile,mode)"
    puts $file "set tile(mode) $prefs(tile,mode)"
    global blink
    puts $file "global blink"
    puts $file "set prefs(blink,interval) $prefs(blink,interval)"
    puts $file "set blink(interval) $prefs(blink,interval)"

    # Bin prefs
    puts $file ""
    puts $file "\# Bin prefs"
    global bin
    puts $file "global bin"
    puts $file "set prefs(bin,function) $prefs(bin,function)"
    puts $file "set bin(function) $prefs(bin,function)"
    puts $file "set prefs(bin,factor) \{$prefs(bin,factor)\}"
    puts $file "set bin(factor) \{$prefs(bin,factor)\}"
    puts $file "set prefs(bin,depth) $prefs(bin,depth)"
    puts $file "set bin(depth) $prefs(bin,depth)"
    puts $file "set prefs(bin,buffersize) $prefs(bin,buffersize)"
    puts $file "set bin(buffersize) $prefs(bin,buffersize)"

    # Zoom prefs
    puts $file ""
    puts $file "\# Zoom prefs"
    global current
    puts $file "global current"
    global wcs
    puts $file "global wcs"
    puts $file "set prefs(wcs,align) $prefs(wcs,align)"
    puts $file "set wcs(align) $prefs(wcs,align)"
    puts $file "set prefs(wcs,align,system) $prefs(wcs,align,system)"
    puts $file "set wcs(align,system) $prefs(wcs,align,system)"
    puts $file "set prefs(wcs,align,sky) $prefs(wcs,align,sky)"
    puts $file "set wcs(align,sky) $prefs(wcs,align,sky)"
    puts $file "set prefs(zoom) \{$prefs(zoom)\}"
    puts $file "set current(zoom) \{$prefs(zoom)\}"
    puts $file "set prefs(orient) $prefs(orient)"
    puts $file "set current(orient) $prefs(orient)"
    puts $file "set prefs(rotate) $prefs(rotate)"
    puts $file "set current(rotate) $prefs(rotate)"

    # Scale prefs
    puts $file ""
    puts $file "\# Scale prefs"
    global current
    puts $file "global current"
    global scale
    puts $file "global scale"
    puts $file "set prefs(scale) $prefs(scale)"
    puts $file "set scale(type) $prefs(scale)"
    puts $file "set prefs(scale,mode) $prefs(scale,mode)"
    puts $file "set scale(mode) $prefs(scale,mode)"
    puts $file "set prefs(scale,scope) $prefs(scale,scope)"
    puts $file "set scale(scope) $prefs(scale,scope)"
    puts $file "set prefs(scale,datasec) $prefs(scale,datasec)"
    puts $file "set scale(datasec) $prefs(scale,datasec)"

    global minmax
    puts $file "global minmax"
    puts $file "set prefs(minmax,mode) $prefs(minmax,mode)"
    puts $file "set minmax(mode) $prefs(minmax,mode)"
    puts $file "set prefs(minmax,sample) $prefs(minmax,sample)"
    puts $file "set minmax(sample) $prefs(minmax,sample)"

    # Color prefs
    puts $file ""
    puts $file "\# Color prefs"
    global colorbar
    puts $file "global colorbar"
    puts $file "set prefs(colorbar,map) $prefs(colorbar,map)"
    puts $file "set colorbar(map) $prefs(colorbar,map)"
    puts $file "set prefs(colorbar,invert) $prefs(colorbar,invert)"
    puts $file "set colorbar(invert) $prefs(colorbar,invert)"

    # Region prefs
    puts $file ""
    puts $file "\# Region prefs"
    global marker
    puts $file "global marker"
    puts $file "set prefs(marker,shape) \{$prefs(marker,shape)\}"
    puts $file "set marker(shape) \{$prefs(marker,shape)\}"
    puts $file "set prefs(marker,color) $prefs(marker,color)"
    puts $file "set marker(color) $prefs(marker,color)"
    puts $file "set prefs(marker,width) $prefs(marker,width)"
    puts $file "set marker(width) $prefs(marker,width)"

    puts $file "set prefs(marker,edit) $prefs(marker,edit)"
    puts $file "set marker(edit) $prefs(marker,edit)"
    puts $file "set prefs(marker,move) $prefs(marker,move)"
    puts $file "set marker(move) $prefs(marker,move)"
    puts $file "set prefs(marker,rotate) $prefs(marker,rotate)"
    puts $file "set marker(rotate) $prefs(marker,rotate)"
    puts $file "set prefs(marker,delete) $prefs(marker,delete)"
    puts $file "set marker(delete) $prefs(marker,delete)"
    puts $file "set prefs(marker,fixed) $prefs(marker,fixed)"
    puts $file "set marker(fixed) $prefs(marker,fixed)"
    puts $file "set prefs(marker,include) $prefs(marker,include)"
    puts $file "set marker(include) $prefs(marker,include)"
    puts $file "set prefs(marker,source) $prefs(marker,source)"
    puts $file "set marker(source) $prefs(marker,source)"
    puts $file "set prefs(marker,font) $prefs(marker,font)"
    puts $file "set marker(font) $prefs(marker,font)"
    puts $file "set prefs(marker,font,size) $prefs(marker,font,size)"
    puts $file "set marker(font,size) $prefs(marker,font,size)"
    puts $file "set prefs(marker,font,style) $prefs(marker,font,style)"
    puts $file "set marker(font,style) $prefs(marker,font,style)"

    puts $file "set prefs(marker,format) $prefs(marker,format)"
    puts $file "set marker(format) $prefs(marker,format)"
    puts $file "set prefs(marker,strip) $prefs(marker,strip)"
    puts $file "set marker(strip) $prefs(marker,strip)"
    puts $file "set prefs(marker,wcs) $prefs(marker,wcs)"
    puts $file "set marker(wcs) $prefs(marker,wcs)"
    puts $file "set prefs(marker,system) $prefs(marker,system)"
    puts $file "set marker(system) $prefs(marker,system)"
    puts $file "set prefs(marker,sky) $prefs(marker,sky)"
    puts $file "set marker(sky) $prefs(marker,sky)"
    puts $file "set prefs(marker,skyformat) $prefs(marker,skyformat)"
    puts $file "set marker(skyformat) $prefs(marker,skyformat)"

    puts $file "set marker(dialog,system) $marker(dialog,system)"
    puts $file "set marker(dialog,sky) $marker(dialog,sky)"
    puts $file "set marker(dialog,skyformat) $marker(dialog,skyformat)"
    puts $file "set marker(dialog,dist,system) $marker(dialog,dist,system)"
    puts $file "set marker(dialog,dist,format) $marker(dialog,dist,format)"

    puts $file "set marker(circle,radius) $marker(circle,radius)"
    puts $file "set marker(ellipse,radius1) $marker(ellipse,radius1)"
    puts $file "set marker(ellipse,radius2) $marker(ellipse,radius2)"
    puts $file "set marker(box,radius1) $marker(box,radius1)"
    puts $file "set marker(box,radius2) $marker(box,radius2)"
    puts $file "set marker(polygon,width) $marker(polygon,width)"
    puts $file "set marker(polygon,height) $marker(polygon,height)"
    puts $file "set marker(projection,thick) $marker(projection,thick)"
    puts $file "set marker(annulus,inner) $marker(annulus,inner)"
    puts $file "set marker(annulus,outer) $marker(annulus,outer)"
    puts $file "set marker(annulus,annuli) $marker(annulus,annuli)"
    puts $file "set marker(ellipseannulus,radius1) $marker(ellipseannulus,radius1)"
    puts $file "set marker(ellipseannulus,radius2) $marker(ellipseannulus,radius2)"
    puts $file "set marker(ellipseannulus,radius3) $marker(ellipseannulus,radius3)"
    puts $file "set marker(ellipseannulus,annuli) $marker(ellipseannulus,annuli)"
    puts $file "set marker(boxannulus,radius1) $marker(boxannulus,radius1)"
    puts $file "set marker(boxannulus,radius2) $marker(boxannulus,radius2)"
    puts $file "set marker(boxannulus,radius3) $marker(boxannulus,radius3)"
    puts $file "set marker(boxannulus,annuli) $marker(boxannulus,annuli)"
    puts $file "set marker(panda,inner) $marker(panda,inner)"
    puts $file "set marker(panda,outer) $marker(panda,outer)"
    puts $file "set marker(panda,annuli) $marker(panda,annuli)"
    puts $file "set marker(panda,ang1) $marker(panda,ang1)"
    puts $file "set marker(panda,ang2) $marker(panda,ang2)"
    puts $file "set marker(panda,angnum) $marker(panda,angnum)"
    puts $file "set marker(epanda,radius1) $marker(epanda,radius1)"
    puts $file "set marker(epanda,radius2) $marker(epanda,radius2)"
    puts $file "set marker(epanda,radius3) $marker(epanda,radius3)"
    puts $file "set marker(epanda,annuli) $marker(epanda,annuli)"
    puts $file "set marker(epanda,ang1) $marker(epanda,ang1)"
    puts $file "set marker(epanda,ang2) $marker(epanda,ang2)"
    puts $file "set marker(epanda,angnum) $marker(epanda,angnum)"
    puts $file "set marker(bpanda,radius1) $marker(bpanda,radius1)"
    puts $file "set marker(bpanda,radius2) $marker(bpanda,radius2)"
    puts $file "set marker(bpanda,radius3) $marker(bpanda,radius3)"
    puts $file "set marker(bpanda,annuli) $marker(bpanda,annuli)"
    puts $file "set marker(bpanda,ang1) $marker(bpanda,ang1)"
    puts $file "set marker(bpanda,ang2) $marker(bpanda,ang2)"
    puts $file "set marker(bpanda,angnum) $marker(bpanda,angnum)"

    # WCS prefs
    puts $file ""
    puts $file "\# wcs prefs"
    global wcs
    puts $file "global wcs"
    puts $file "set prefs(wcs,system) $prefs(wcs,system)"
    puts $file "set wcs(system) $prefs(wcs,system)"
    puts $file "set prefs(wcs,sky) $prefs(wcs,sky)"
    puts $file "set wcs(sky) $prefs(wcs,sky)"
    puts $file "set prefs(wcs,skyformat) $prefs(wcs,skyformat)"
    puts $file "set wcs(skyformat) $prefs(wcs,skyformat)"

    # Analysis prefs
    puts $file ""
    puts $file "\# Analysis prefs"
    global graph
    puts $file "global graph"
    puts $file "set graph(horz,grid) $graph(horz,grid)"
    puts $file "set graph(horz,log) $graph(horz,log)"
    puts $file "set graph(vert,grid) $graph(vert,grid)"
    puts $file "set graph(vert,log) $graph(vert,log)"
    global contour
    puts $file "global contour"
    puts $file "set prefs(contour,method) $prefs(contour,method)"
    puts $file "set contour(method) $prefs(contour,method)"
    puts $file "set prefs(contour,color) $prefs(contour,color)"
    puts $file "set contour(color) $prefs(contour,color)"
    puts $file "set prefs(contour,width) $prefs(contour,width)"
    puts $file "set contour(width) $prefs(contour,width)"
    global smooth
    puts $file "global smooth"
    puts $file "set prefs(smooth,function) $prefs(smooth,function)"
    puts $file "set smooth(function) $prefs(smooth,function)"
    puts $file "set prefs(smooth,radius) $prefs(smooth,radius)"
    puts $file "set smooth(radius) $prefs(smooth,radius)"
    global nres
    puts $file "global nres"
    puts $file "set nres(server) \{$nres(server)\}"
    global dss
    puts $file "global dss"
    puts $file "set dss(server) \{$dss(server)\}"
    global cat
    puts $file "global cat"
    puts $file "set cat(server) \{$cat(server)\}"
    puts $file "set cat(sym,shape) \{$cat(sym,shape)\}"
    puts $file "set cat(sym,color) $cat(sym,color)"

    global hv
    puts $file "global hv"
    foreach n {1 2 3 4} {
	puts $file "set hv(archive,menu,$n) \{$hv(archive,menu,$n)\}"
	puts $file "set hv(archive,url,$n) \{$hv(archive,url,$n)\}"
    }
    global vo
    puts $file "global vo"
    puts $file "set vo(server) \{$vo(server)\}"
    puts $file "set vo(hv) $vo(hv)"
    puts $file "set vo(method) $vo(method)"

    puts $file "set ds9(analysis,user)  \{$ds9(analysis,user)\}"
    puts $file "set ds9(analysis,user2) \{$ds9(analysis,user2)\}"
    puts $file "set ds9(analysis,user3) \{$ds9(analysis,user3)\}"
    puts $file "set ds9(analysis,user4) \{$ds9(analysis,user4)\}"

    global analysis
    puts $file "global analysis"
    puts $file "set prefs(analysis,log) $prefs(analysis,log)"
    puts $file "set analysis(log) $prefs(analysis,log)"

    puts $file ""
    puts $file "\# Analysis Plot prefs"
    puts $file "set prefs(ap,grid) $prefs(ap,grid)"
    puts $file "set prefs(ap,grid,log) $prefs(ap,grid,log)"

    puts $file "set prefs(ap,discrete) $prefs(ap,discrete)"
    puts $file "set prefs(ap,discrete,symbol) $prefs(ap,discrete,symbol)"
    puts $file "set prefs(ap,discrete,color) $prefs(ap,discrete,color)"

    puts $file "set prefs(ap,linear) $prefs(ap,linear)"
    puts $file "set prefs(ap,linear,width) $prefs(ap,linear,width)"
    puts $file "set prefs(ap,linear,color) $prefs(ap,linear,color)"
    puts $file "set prefs(ap,linear,dash) $prefs(ap,linear,dash)"

    puts $file "set prefs(ap,step) $prefs(ap,step)"
    puts $file "set prefs(ap,step,width) $prefs(ap,step,width)"
    puts $file "set prefs(ap,step,color) $prefs(ap,step,color)"
    puts $file "set prefs(ap,step,dash) $prefs(ap,step,dash)"

    puts $file "set prefs(ap,quadratic) $prefs(ap,quadratic)"
    puts $file "set prefs(ap,quadratic,width) $prefs(ap,quadratic,width)"
    puts $file "set prefs(ap,quadratic,color) $prefs(ap,quadratic,color)"
    puts $file "set prefs(ap,quadratic,dash) $prefs(ap,quadratic,dash)"

    puts $file "set prefs(ap,error,width) $prefs(ap,error,width)"
    puts $file "set prefs(ap,error,color) $prefs(ap,error,color)"
    puts $file "set prefs(ap,error,style) $prefs(ap,error,style)"

    puts $file "set prefs(ap,titleFont) $prefs(ap,titleFont)"
    puts $file "set prefs(ap,titleSize) $prefs(ap,titleSize)"
    puts $file "set prefs(ap,titleStyle) $prefs(ap,titleStyle)"

    puts $file "set prefs(ap,textlabFont) $prefs(ap,textlabFont)"
    puts $file "set prefs(ap,textlabSize) $prefs(ap,textlabSize)"
    puts $file "set prefs(ap,textlabStyle) $prefs(ap,textlabStyle)"

    puts $file "set prefs(ap,numlabFont) $prefs(ap,numlabFont)"
    puts $file "set prefs(ap,numlabSize) $prefs(ap,numlabSize)"
    puts $file "set prefs(ap,numlabStyle) $prefs(ap,numlabStyle)"

    # Language
    puts $file ""
    puts $file "\# Language"
    puts $file "set ds9(language) $ds9(language)"

    # Mask Color prefs
    puts $file ""
    puts $file "\# Mask Color prefs"
    puts $file "set ds9(mask,color) $ds9(mask,color)"

    # Background Color prefs
    puts $file ""
    puts $file "\# Background Color prefs"
    puts $file "set ds9(bg,color) $ds9(bg,color)"

    # Blank/Inf/NaN Color prefs
    puts $file ""
    puts $file "\# Blank/Inf/NaN Color prefs"
    puts $file "set ds9(nan,color) $ds9(nan,color)"

    # Default Font prefs
    puts $file ""
    puts $file "\# Font prefs"
    puts $file "set ds9(font) $ds9(font)"
    puts $file "set ds9(font,size) $ds9(font,size)"
    puts $file "set ds9(font,style) $ds9(font,style)"
    puts $file "if \{\$ds9\(font\) \!\= \"default\"\} \{"
    puts $file "option add *font \{$ds9(font) $ds9(font,size) $ds9(font,style)\}"
    puts $file "\}"

    # Mosaic prefs
    puts $file ""
    puts $file "\# Mosaic prefs"
    puts $file "set ds9(mosaic,fast) $ds9(mosaic,fast)"

    # Panner prefs
    puts $file ""
    puts $file "\# Panner prefs"
    global panner
    puts $file "global panner"
    puts $file "set panner(compass,image) $panner(compass,image)"
    puts $file "set panner(compass,wcs) $panner(compass,wcs)"
    puts $file "set panner(compass,wcs,system) $panner(compass,wcs,system)"
    puts $file "set panner(compass,wcs,sky) $panner(compass,wcs,sky)"

    # Magnifier prefs
    puts $file ""
    puts $file "\# Magnifier prefs"
    global magnifier
    puts $file "global magnifier"
    puts $file "set magnifier(region) $magnifier(region)"
    puts $file "set magnifier(cursor) $magnifier(cursor)"
    puts $file "set magnifier(zoom) $magnifier(zoom)"

    # Truecolor Colorbar prefs
    puts $file ""
    puts $file "\# Truecolor Colorbar prefs"
    global colorbar
    puts $file "global colorbar"
    puts $file "set colorbar(area) $colorbar(area)"
    puts $file "set colorbar(mode) $colorbar(mode)"

    # Dialog prefs
    puts $file ""
    puts $file "\# Dialog prefs"
    puts $file "global ds9"
    puts $file "set ds9(dialog) $ds9(dialog)"

    # PanZoom prefs
    puts $file ""
    puts $file "\# PanZoom prefs"
    global panzoom
    puts $file "global panzoom"
    puts $file "set panzoom(mode) $panzoom(mode)"

    # Print Coordinates prefs
    puts $file ""
    puts $file "\# Print Coordinates prefs"
    global coord
    puts $file "global coord"
    puts $file "set coord(value) $coord(value)"
    puts $file "set coord(image) $coord(image)"
    puts $file "set coord(physical) $coord(physical)"
    puts $file "set coord(amplifier) $coord(amplifier)"
    puts $file "set coord(detector) $coord(detector)"
    foreach l {{} a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	puts $file "set coord(wcs$l) $coord(wcs$l)"
    }
    puts $file "set coord(sky) $coord(sky)"
    puts $file "set coord(skyformat) $coord(skyformat)"

    # Examine prefs
    puts $file ""
    puts $file "\# Examine prefs"
    global examine
    puts $file "global examine"
    puts $file "set examine(mode) $examine(mode)"
    puts $file "set examine(zoom) $examine(zoom)"

    # Misc prefs
    puts $file ""
    puts $file "\# Misc prefs"
    global menu
    puts $file "global menu"
    puts $file "set ds9(tmpdir) \{$ds9(tmpdir)\}"
    puts $file "set ds9(automarker) $ds9(automarker)"
    puts $file "set ds9(xpa) $ds9(xpa)"

    # HTTP prefs
    puts $file ""
    puts $file "\# HTTP prefs"
    global http
    puts $file "global http"
    puts $file "set http(proxy) $http(proxy)"
    puts $file "set http(proxy,host) \{$http(proxy,host)\}"
    puts $file "set http(proxy,port) \{$http(proxy,port)\}"
    puts $file "set http(auth) $http(auth)"
    puts $file "set http(auth,user) \{$http(auth,user)\}"
    puts $file "set http(auth,passwd) \{$http(auth,passwd)\}"

    # and close
    close $file
}

# Process Cmds

proc ProcessPrefsCmd {varname iname} {
    upvar $varname var
    upvar $iname i

    global prefs
    global ds9
    global wcs

    switch -- [string tolower [lindex $var $i]] {
	clear {ClearPrefs}
	mosaicfast {
	    incr i
	    set ds9(mosaic,fast) [FromYesNo [lindex $var $i]]
	    PrefsMosaicFast
	}
	maskcolor {
	    incr i
	    set ds9(mask,color) [lindex $var $i]
	    PrefsMaskColor
	}
	bgcolor {
	    incr i
	    set ds9(bg,color) [lindex $var $i]
	    PrefsBkgrColor
	}
	nancolor {
	    incr i
	    set ds9(nan,color) [lindex $var $i]
	    PrefsNaNColor
	}
    }
}
